      module PSDPARA
	implicit none  
      real*8 para_bimax_in(10)
      real*8 para_pwl_in(10)
      common /PSDPARADATA/ para_bimax_in,para_pwl_in
      end module

	module mod_dfvvpa_data
	implicit none
	integer*4 nVVMAX0,nPAMAX0
	integer*4 nVV,nPA
	parameter(nVVMAX0=100,nPAMAX0=100)
	real*8 VVARR(nVVMAX0),PAARR(nPAMAX0)
	real*8 LNPSD2d(nVVMAX0,nPAMAX0)  
	real*8 VVMASK(2),PAMASK(2),VZMASK(2),VPMASK(2)  
	character*3 psdscl
	common /dfvvpa_data_com/ VVARR,PAARR,LNPSD2d,
     1 VVMASK,PAMASK,VZMASK,VPMASK,
     2 nVV,nPA,psdscl
	end module

	subroutine dfvvpa_data_setup(nVVnew,nPAnew,
     1	    VVARRnew,PAARRnew,LNPSD2dnew,MASKnew,psdsclnew)
	use mod_dfvvpa_data  
	implicit none
	integer*4 nVVnew,nPAnew
	real*8 VVARRnew(nVVMAX0),PAARRnew(nPAMAX0)
	real*8 LNPSD2dnew(nVVMAX0,nPAMAX0)  
	real*8 MASKnew(3,10)  
	character*3 psdsclnew
	nVV=nVVnew
	nPA=nPAnew
	VVARR(1:nVV)=VVARRnew(1:nVV)
	PAARR(1:nPA)=PAARRnew(1:nPA)
	LNPSD2d(1:nVV,1:nPA)=LNPSD2dnew(1:nVV,1:nPA)  

	VVMASK=(/ 0d0, 3d8 /)  
	if(MASKnew(1,1).gt.0)  then
		VVMASK(1:2)=MASKnew(2:3,1)
	endif  

	PAMASK=(/ 0d0, 3.1415927d0 /)  
	if(MASKnew(1,2).gt.0)  then
		PAMASK(1:2)=MASKnew(2:3,2)
	endif  

	VZMASK = (/ -3d8, 3d8 /)
	if(MASKnew(1,3).gt.0)  then
		VZMASK(1:2)=MASKnew(2:3,3)
	endif  

	VPMASK = (/ 0d0, 3d8 /)
	if(MASKnew(1,4).gt.0)  then
		VPMASK(1:2)=MASKnew(2:3,4)
	endif  

	psdscl=psdsclnew
	end

	subroutine PSD_deriv(vz,vp,f,dfdvz,dfdvp)
c     para_dpsd = 0-2 dfram from RAM PSD
c     para_dpsd = 3  ring
c     para_dpsd = 4 bimax 
c     para_dpsd = 5 powerlaw dfpwl
      use PSDPARA
      use mod_PhyConst
      use mod_WavesWork
	implicit none  

	real*8 Ex,PAx
      real*8 para_bimax(10),para_pwl(10)
      real*8 vz,vp,f,dfdvz,dfdvp
c           
      if(psdmdl.eq.'ram0xx') then
            call dfram(vz,vp,f,dfdvz,dfdvp)

      elseif (psdmdl.eq.'ram2xx') then
            call dfram2(vz,vp,f,dfdvz,dfdvp)

      elseif (psdmdl.eq.'ram3xx') then
            call dfram3(vz,vp,f,dfdvz,dfdvp)

      elseif (psdmdl.eq.'dframX') then
            call dframX(vz,vp,f,dfdvz,dfdvp)


      elseif (psdmdl.eq.'dfdata') then
            call dfvvpa_data(vz,vp,f,dfdvz,dfdvp)

      elseif (psdmdl.eq.'dfvvpa') then
            call dfvvpa(vz,vp,f,dfdvz,dfdvp)
      elseif (psdmdl.eq.'dfvzvp') then
            call dfvzvp(vz,vp,f,dfdvz,dfdvp)


      elseif (psdmdl.eq.'Hn00MS') then

c     ring distribution from Horne 2000      
        para_bimax(1:9)=(/1.0,1.0,4.0e5,20e3,25e3,
     1   -1.0,-1.0,0.9088,0.0/)
        call bimax(vz,vp,f,dfdvz,dfdvp,para_bimax)


      elseif (psdmdl.eq.'bimxH0') then
c     bi-maxiwellian distribution      
        para_bimax(1:9)=(/1.0d0,1.0d0,1.0d5,15d3,30d3,
     1   -1.0d0,-1.0d0,0.5d0,1.0d0/)
        call bimax(vz,vp,f,dfdvz,dfdvp,para_bimax)



      elseif (psdmdl.eq.'pwBt07') then
c     Bortnik 2007      
c     power law distribution function       
      para_pwl(1:4)=(/-1.0d0,memp,1.17d8,3.51d0/)
      call dfpwl(vz,vp,f,dfdvz,dfdvp,para_pwl)

      elseif (psdmdl.eq.'powerl') then
c     power law distribution function       
      para_pwl(1:4)=para_pwl_in(1:4)
      call dfpwl(vz,vp,f,dfdvz,dfdvp,para_pwl)

      elseif (psdmdl.eq.'bimxe0') then
c     bi-maxiwellian distribution      
        para_bimax(1:9)=(/-1.0d0,memp,1.0d3,15d3,30d3,
     1   -1.0d0,-1.0d0,0.5d0,1.0d0/)
        call bimax(vz,vp,f,dfdvz,dfdvp,para_bimax)

      elseif (psdmdl.eq.'bimxe1') then
c     bi-maxiwellian distribution      
        para_bimax(1:9)=(/-1.0d0,memp,1.0d5,0d3,0d3,
     1   3d7,5d7,0.5d0,1.0d0/)
        call bimax(vz,vp,f,dfdvz,dfdvp,para_bimax)

      elseif (psdmdl.eq.'bimaxi') then
c     bi-maxiwellian distribution      
        para_bimax(1:9)=para_bimax_in(1:9)
        call bimax(vz,vp,f,dfdvz,dfdvp,para_bimax)

      elseif (psdmdl.eq.'sthem0') then
        call sthem(vz,vp,f,dfdvz,dfdvp)
      elseif (psdmdl.eq.'sthemd') then
        call sthem_data(vz,vp,f,dfdvz,dfdvp)
      elseif (psdmdl.eq.'sthemL') then
        call sthem_data_L(vz,vp,f,dfdvz,dfdvp)

      else

      endif



c      write(*,15) vz,vp,f,dfdvz,dfdvp
c 15   format(1x,5(g14.5,2x))       

	end subroutine





      subroutine test_bimax
      real*8 para(10)
      real*8 vp,vz,f,dfdvp,dfdvz
      real*8 vp1,vz1,f1,dfdvp1,dfdvz1
      para(1:9)=(/1.0,1.0,4.0e5,25e3,20e3,-1.0,-1.0,0.9088,0.0/)
      vz=0.0
      vp=0.0
      do while (vp.ge.0.0)
      write(*,*)'vp,vz'
      read(*,*)vz,vp
      call bimax(vz,vp,f,dfdvp,dfdvz,para)
      write(*,*)'vp,vz,f,dfdvp,dfdvz'
      vp1=real(vp)
      vz1=real(vz)
      f1=real(f)
      dfdvp1=real(dfdvp)
      dfdvz1=real(dfdvz)
      write(*,*)vp,vz,f,dfdvp,dfdvz
      write(*,*)vp1,vz1,f1,dfdvp1,dfdvz1
      enddo
      end



      subroutine bimax(vz,vp,f,dfdvz,dfdvp,para)
c     bimaxwellian distribution      
c     para: iq imas iden iEz iEp ialphaz ialphap ibeta idelta
      use mod_PhyConst
      implicit none

      real*8 vp,vz,f,dfdvp,dfdvz
      real*8 para(*)
      real*8 iq,imas,iden,iEp,iEz,ialphap,ialphaz,ibeta,idelta
      real*8 exp_z,exp_pbeta,exp_p
      real*8 dexp_z,dexp_pbeta,dexp_p
      real*8 fac0,fac1
      real*8 ialphap2,ialphaz2
      

      iq=para(1)
      imas=para(2)
      iden=para(3)
      iEz=para(4)
      iEp=para(5) ! in ev
      ialphaz=para(6)
      ialphap=para(7)
      ibeta=para(8)
      idelta=para(9)
      
      if (ialphap.lt.-1.0d-9) then
      ialphap2=(2.0*iEp*ev/(imas*hmas))
      ialphaz2=(2.0*iEz*ev/(imas*hmas))
      ialphap=dsqrt(ialphap2)
      ialphaz=dsqrt(ialphaz2)
      else
      ialphap2=ialphap*ialphap
      ialphaz2=ialphaz*ialphaz
      iEp=2.0d0*(imas*hmas)*ialphap2/ev
      iEz=2.0d0*(imas*hmas)*ialphaz2/ev
c      write(*,*) iEp,iEz
c      stop
      endif

      fac0=iden/(pi**(3.0/2.0)*ialphap2*ialphaz)
      fac1=(1.0-idelta)/(1.0-ibeta)

      exp_z=dexp(-1.0*vz*vz/ialphaz2)
      exp_p=dexp(-1.0*vp*vp/ialphap2)
      exp_pbeta=dexp(-1.0*vp*vp/(ialphap2*ibeta))
      dexp_p=exp_p*(-2.0*vp)/ialphap2
      dexp_z=exp_z*(-2.0*vz)/ialphaz2
      dexp_pbeta=exp_pbeta*(-2.0*vp)/(ialphap2*ibeta)
      
      f=fac0*exp_z*(idelta*exp_p+fac1*(exp_p-exp_pbeta))
      dfdvp=fac0*exp_z*(idelta*dexp_p+fac1*(dexp_p-dexp_pbeta))
      dfdvz=fac0*dexp_z*(idelta*exp_p+fac1*(exp_p-exp_pbeta))

      end

      subroutine dfpwl(vz,vp,f,dfdvz,dfdvp,para)
c     in unit of m-6 s-3      
c     f(v)=AN/v**npw   
c     para: iq imas AN npw

      use mod_PhyConst
      implicit none

      real*8 vp,vz,f,dfdvp,dfdvz
      real*8 para(*)
      real*8 iq,imas
      real*8 AN,npw,vv
      real*8 ialphap2,ialphaz2
      iq=para(1)
      imas=para(2)
      AN=para(3)
      npw=para(4)
      vv=dsqrt(vp*vp+vz*vz)
      f=AN/vv**npw
c     d vv / d vp = vp / vv
c     d vv / d vz = vp / vz

      dfdvp=f*(-1.d0)*npw/vv*(vp/vv)
      dfdvz=f*(-1.d0)*npw/vv*(vz/vv)
      end 

      subroutine dfpwl2(vz,vp,f,dfdvz,dfdvp,para)
c     in unit of m-6 s-3      
c     f(v)=AN*vp**(2*p)/(v*v+v0*v0)**q   
c     para: iq imas AN p q v0

      use mod_PhyConst
      implicit none
      real*8 vp,vz,f,dfdvp,dfdvz
      real*8 para(*)
      real*8 iq,imas
      real*8 AN,vv,v2,v0,p,q,vterm
      real*8 ialphap2,ialphaz2
      iq=para(1)
      imas=para(2)
      AN=para(3)
      p=para(4)
      q=para(5)
      v0=para(6)



      v2=vp*vp+vz*vz
      vterm=v2+v0*v0
      vv=dsqrt(v2)
      f=AN*vp**(2*p)/(vterm)**q
c     d vv / d vp = vp / vv
c     d vv / d vz = vp / vz

      dfdvp=f*(2.0d0*p)/vp+f*(-2.0d0*q)/vterm*vp
      dfdvz=f*(-2.0d0*q)/vterm*vz
      end 


	subroutine dfram2(vz0,vp,f,dfdvz,dfdvp)
	use mod_PhyConst
      use mod_WavesWork
	use mod_RAM
	implicit none  

	real*8 Ex,PAx
	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,PAr,dfdPAr,vz0  
	real*8 lnpsd,lnpsd0,dlnpsddPA,dlnpsddv
      real*8 signvz
	integer*4 dimarr(10),ivp
	real*8 imas
      integer*4 iE,iPA

	dimarr(1)=NE0
	dimarr(2)=NPA0
	dimarr(3)=NE0
	dimarr(4)=NPA0

      imas=THISimas
      signvz=1.0d0
      if(vz0.lt.0.0d0) signvz=-1.0d0
      vz=signvz*vz0
	vv=dsqrt(vp*vp+vz*vz)
	Ex=0.5*hmas*imas*vv*vv/(ev*1e3)
	PAr=dasin(vp/vv)
	PAx=PAr/rad
c     interpolation and extrapolation      
c     in the domain of energy and pitch angle
c     what about in velocity and pitch angle
      if((PAx.ge.PA0MIN).and.(PAx.le.PA0MAX).and.
     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
	call linearinterp2d(THISVV,THISPA0,THISLNPSD,vv,PAx,
     1    lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      elseif((PAx.gt.PA0MAX) .and.
     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
	call linearinterp2d(THISVV,THISPA0,THISLNPSD,vv,PA0MAX,
     1    lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      dlnpsddPA=0.0d0
c      elseif((PAx.lt.PA0MIN) .and.
c     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
c	call linearinterp2d(THISvv,THISPA0,THISLNPSD,vv,PA0MIN,
c     1    lnpsd,dlnpsddv,dlnpsddPA,dimarr)
c      dlnpsddPA=0.0d0
c      elseif ((Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
      else
c	call linearinterp2d(THISE0,THISPA0,THISLNPSD,Ex,PA0MAX,
c     1    lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      lnpsd=-100.0d0
      dlnpsddPA=0.0d0
      dlnpsddv=0.0d0
      endif

	f=dexp(lnpsd)  
c	dfdv=f*dlnpsddE*hmas*imas*vv/(ev*1e3)  
	dfdv=f*dlnpsddv  
c     -1 as a result of PA decreasing
c      dlnpsddPA=-1.0*dlnpsddPA
	dfdPAr=f*dlnpsddPA/rad  
	dfdvz=(dfdv*vz/vv-dfdPAr*vp/(vv*vv))*signvz
	dfdvp=dfdv*vp/vv+dfdPAr*vz/(vv*vv)
      end


	subroutine dfram(vz0,vp,f,dfdvz,dfdvp)
	use mod_PhyConst
      use mod_WavesWork
	use mod_RAM
	implicit none  

	real*8 Ex,PAx
	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,PAr,dfdPAr,vz0  
	real*8 lnpsd,lnpsd0,dlnpsddPA,dlnpsddE
      real*8 signvz
	integer*4 dimarr(10),ivp
	real*8 imas
      integer*4 iE,iPA

	dimarr(1)=NE0
	dimarr(2)=NPA0
	dimarr(3)=NE0
	dimarr(4)=NPA0

      imas=THISimas
      signvz=1.0d0
      if(vz0.lt.0.0d0) signvz=-1.0d0
      vz=signvz*vz0
	vv=dsqrt(vp*vp+vz*vz)
	Ex=0.5*hmas*imas*vv*vv/(ev*1e3)
	PAr=dasin(vp/vv)
	PAx=PAr/rad
c     interpolation and extrapolation      
c     in the domain of energy and pitch angle
c     what about in velocity and pitch angle
      if((PAx.ge.PA0MIN).and.(PAx.le.PA0MAX).and.
     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
	call linearinterp2d(THISE0,THISPA0,THISLNPSD,Ex,PAx,
     1    lnpsd,dlnpsddE,dlnpsddPA,dimarr)
      elseif((PAx.gt.PA0MAX) .and.
     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
	call linearinterp2d(THISE0,THISPA0,THISLNPSD,Ex,PA0MAX,
     1    lnpsd,dlnpsddE,dlnpsddPA,dimarr)
      dlnpsddPA=0.0d0
c      elseif((PAx.lt.PA0MIN) .and.
c     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
c	call linearinterp2d(THISE0,THISPA0,THISLNPSD,Ex,PA0MIN,
c     1    lnpsd,dlnpsddE,dlnpsddPA,dimarr)
c      dlnpsddPA=0.0d0
c      elseif ((Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
      else
c	call linearinterp2d(THISE0,THISPA0,THISLNPSD,Ex,PA0MAX,
c     1    lnpsd,dlnpsddE,dlnpsddPA,dimarr)
      lnpsd=-100.0d0
      dlnpsddPA=0.0d0
      dlnpsddE=0.0d0
      endif

	f=dexp(lnpsd)  
	dfdv=f*dlnpsddE*hmas*imas*vv/(ev*1e3)  
c     -1 as a result of PA decreasing
c      dlnpsddPA=-1.0*dlnpsddPA
	dfdPAr=f*dlnpsddPA/rad  
	dfdvz=(dfdv*vz/vv-dfdPAr*vp/(vv*vv))*signvz
	dfdvp=dfdv*vp/vv+dfdPAr*vz/(vv*vv)
      end

	subroutine dfram3(vz0,vp,f,dfdvz,dfdvp)
c     NOTE that discontinity in the first derivative
c     due to precision of calculating sine and cose function
	use mod_PhyConst
      use mod_WavesWork
	use mod_RAM
	implicit none  

	real*8 Ex,PAx,sPAr
	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,PAr,dfdPAr,vz0  
	real*8 lnpsd,lnpsd0,dlnpsddPA,dlnpsddv,dlnpsddsPA
      real*8 signvz
	integer*4 dimarr(10),ivp
	real*8 imas
      integer*4 iE,iPA
      

	dimarr(1)=NE0
	dimarr(2)=NPA0
	dimarr(3)=NE0
	dimarr(4)=NPA0
      imas=THISimas
      signvz=1.0d0
      if(vz0.lt.0.0d0) signvz=-1.0d0
      vz=signvz*vz0
	vv=dsqrt(vp*vp+vz*vz)
	Ex=0.5*hmas*imas*vv*vv/(ev*1e3)
      sPAr=vp/vv
	PAr=dasin(sPAr)
	PAx=PAr/rad
c     interpolation and extrapolation      
c     in the domain of energy and pitch angle
c     what about in velocity and pitch angle
      if((sPAr.ge.THISSPA0MIN).and.(sPAr.le.THISSPA0MAX).and.
     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
	call linearinterp2d(THISVV,THISSPA0,THISLNPSD,vv,sPAr,
     1    lnpsd,dlnpsddv,dlnpsddsPA,dimarr)
      elseif((PAx.gt.PA0MAX) .and.
     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
	call linearinterp2d(THISVV,THISSPA0,THISLNPSD,vv,THISSPA0MAX,
     1    lnpsd,dlnpsddv,dlnpsddsPA,dimarr)
      dlnpsddsPA=0.0d0
c      elseif((sPAr.lt.THISSPA0MIN) .and.
c     1   (Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
c	call linearinterp2d(THISVV,THISSPA0,THISLNPSD,vv,THISSPA0MIN,
c     1    lnpsd,dlnpsddv,dlnpsddsPA,dimarr)
c      dlnpsddPA=0.0d0
c      elseif ((Ex.ge.E0MIN).and.(Ex.le.E0MAX)) then
      else
c	call linearinterp2d(THISVV,THISSPA0,THISLNPSD,vv,THISSPA0MAX,
c     1    lnpsd,dlnpsddv,dlnpsddsPA,dimarr)
      lnpsd=-100.0d0
      dlnpsddsPA=0.0d0
      dlnpsddv=0.0d0
      endif

	f=dexp(lnpsd)  
c	dfdv=f*dlnpsddE*hmas*imas*vv/(ev*1e3)  
	dfdv=f*dlnpsddv  
	dfdPAr=f*dlnpsddsPA*dcos(sPAr)  
	dfdvz=(dfdv*vz/vv-dfdPAr*vp/(vv*vv))*signvz
	dfdvp=dfdv*vp/vv+dfdPAr*vz/(vv*vv)
      end

	subroutine dframX(vz0,vp,f,dfdvz,dfdvp)
c     check ok      
	use mod_PhyConst
      use mod_WavesWork
	use mod_RAM
	implicit none  

	real*8 cPAr
	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,PAr,dfdPAr,vz0
	real*8 lnpsd,lnpsd0,dlnpsddPA,dlnpsddv
      real*8 signvz
	integer*4 dimarr(10),ivp
      integer*4 iVV,iPA
      integer*4 icall
      data icall/0/
      save icall

      if(icall.eq.0) then
      endif

	dimarr(1)=NVDF
	dimarr(2)=NPADF
	dimarr(3)=NVDF
	dimarr(4)=NPADF
     


      vz=vz0
	vv=dsqrt(vp*vp+vz*vz)
      cPAr=vz/vv
	PAr=dacos(cPAr) ! acos range from zero to pi

      if((PAr.ge.PAminnew).and.(PAr.le.PAmaxnew).and.
     1   (vv.ge.VVminnew).and.(vv.le.VVmaxnew)) then
	call linearinterp2d(THISVVnew,THISPAnew,THISLNPSDnew,vv,PAr,
     1    lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      else
            lnpsd=-100.0d0
            dlnpsddPA=0.0d0
            dlnpsddv=0.0d0
      endif

	f=dexp(lnpsd)  
	dfdv=f*dlnpsddv  
	dfdPAr=f*dlnpsddPA
	dfdvz=(dfdv*vz/vv-dfdPAr*vp/(vv*vv))
	dfdvp=dfdv*vp/vv+dfdPAr*vz/(vv*vv)
      icall=icall+1
      end


	subroutine dfvvpa_data(vz0,vp,f,dfdvz,dfdvp)
c     check ok      
	use mod_PhyConst
	use mod_dfvvpa_data
	implicit none  

	real*8 cPAr
	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,PAr,dfdPAr,vz0
	real*8 lnpsd,lnpsd0,dlnpsddPA,dlnpsddv
      real*8 signvz
	integer*4 dimarr(10),ivp
      integer*4 iVV,iPA
      integer*4 icall
      data icall/0/
      save icall

      if(icall.eq.0) then
      endif

	dimarr(1)=NVV
	dimarr(2)=NPA
	dimarr(3)=nVVMAX0 ! define VV dimension
	dimarr(4)=nPAMAX0 ! define PA dimension
     


      vz=vz0
	vv=dsqrt(vp*vp+vz*vz)
      cPAr=vz/vv
	PAr=dacos(cPAr) ! acos range from zero to pi

	if (psdscl.eq.'log') then

      	if(((PAr.ge.PAMASK(1)).and.(PAr.le.PAMASK(2))).and.
     1   	((vv.ge.VVMASK(1)).and.(vv.le.VVMASK(2))).and.
     2   	((vz.ge.VZMASK(1)).and.(vz.le.VZMASK(2))).and.
     3   	((vp.ge.VPMASK(1)).and.(vp.le.VPMASK(2))))
     4    	then
			call linearinterp2d(VVARR,PAARR,LNPSD2d,vv,PAr,
     1    		lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      	else
            	lnpsd=-100.0d0
            	dlnpsddPA=0.0d0
            	dlnpsddv=0.0d0
      	endif

		f=dexp(lnpsd)  
		dfdv=f*dlnpsddv  
		dfdPAr=f*dlnpsddPA

	elseif (psdscl.eq.'lin') then
      	if(((PAr.ge.PAMASK(1)).and.(PAr.le.PAMASK(2))).and.
     1   		((vv.ge.VVMASK(1)).and.(vv.le.VVMASK(2))).and.
     2   		((vz.ge.VZMASK(1)).and.(vz.le.VZMASK(2))).and.
     3   		((vp.ge.VPMASK(1)).and.(vp.le.VPMASK(2))))
     4    	then
			call linearinterp2d(VVARR,PAARR,LNPSD2d,vv,PAr,
     1    		lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      	else
            	lnpsd=0.0d0
            	dlnpsddPA=0.0d0
            	dlnpsddv=0.0d0
      	endif

		f=lnpsd  
		dfdv=dlnpsddv  
		dfdPAr=dlnpsddPA
	else
		stop
	endif



	dfdvz=(dfdv*vz/vv-dfdPAr*vp/(vv*vv))
	dfdvp=dfdv*vp/vv+dfdPAr*vz/(vv*vv)
      icall=icall+1
      end







	subroutine dfvvpa(vz0,vp,f,dfdvz,dfdvp)
c     check ok      
	use mod_PhyConst
	implicit none  

      integer*4 NV1,NPA1
      parameter(NV1=400,NPA1=400)

	real*8 cPAr
	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,PAr,dfdPAr,vz0
	real*8 lnpsd,lnpsd0,dlnpsddPA,dlnpsddv
      real*8 signvz
	integer*4 dimarr(10),ivp
      integer*4 iVV,iPA
      real*8 para_bimax(10)
      real*8 vzi,vpi,fi,dfdvzi,dfdvpi
      integer*4 icall
      data icall/0/
      save icall

      real*8 THISVVnew(NV1),THISPAnew(NPA1)
      real*8 THISLNPSDnew(NV1,NPA1)
      real*8 VVminnew,VVmaxnew
      real*8 PAminnew,PAmaxnew
      common /dfvvpadata/ THISVVnew,THISPAnew,THISLNPSDnew,
     1      VVminnew,VVmaxnew,PAminnew,PAmaxnew 

      if(icall.eq.0) then
              call logspace(THISVVnew,1d1,1d8,NV1)
              call linspace(THISPAnew,0.0d0,pi,NPA1)
              para_bimax(1:9)=(/1.0,1.0,4.0e5,20e3,25e3,
     1   -1.0,-1.0,0.9088,0.0/)
              do iVV=1,NV1
              do iPA=1,NPA1
                  vzi=THISVVnew(iVV)*dcos(THISPAnew(iPA))
                  vpi=THISVVnew(iVV)*dsin(THISPAnew(iPA))
                  call bimax(vzi,vpi,fi,dfdvzi,dfdvpi,para_bimax)
                  if(fi.gt.1d-100) then
                        THISLNPSDnew(iVV,iPA)=dlog(fi)
                  else
                        THISLNPSDnew(iVV,iPA)=-100
                  endif
              enddo
              enddo
            VVminnew=THISVVnew(1)
            VVmaxnew=THISVVnew(NV1)
            PAminnew=THISPAnew(1)
            PAmaxnew=THISPAnew(NPA1)
      endif
	dimarr(1)=NV1
	dimarr(2)=NPA1
	dimarr(3)=NV1
	dimarr(4)=NPA1
     


      vz=vz0
	vv=dsqrt(vp*vp+vz*vz)
      cPAr=vz/vv
	PAr=dacos(cPAr) ! acos range from zero to pi

      if((PAr.ge.PAminnew).and.(PAr.le.PAmaxnew).and.
     1   (vv.ge.VVminnew).and.(vv.le.VVmaxnew)) then
	call linearinterp2d(THISVVnew,THISPAnew,THISLNPSDnew,vv,PAr,
     1    lnpsd,dlnpsddv,dlnpsddPA,dimarr)
      else
            lnpsd=-100.0d0
            dlnpsddPA=0.0d0
            dlnpsddv=0.0d0
      endif

	f=dexp(lnpsd)  
	dfdv=f*dlnpsddv  
	dfdPAr=f*dlnpsddPA
	dfdvz=(dfdv*vz/vv-dfdPAr*vp/(vv*vv))
	dfdvp=dfdv*vp/vv+dfdPAr*vz/(vv*vv)
      icall=icall+1
      end

	subroutine dfvzvp(vz0,vp,f,dfdvz,dfdvp)
c     check ok      
	use mod_PhyConst
	implicit none  
      integer*4 NVZ1,NVP1
      parameter(NVZ1=400,NVP1=200)

	real*8 vp,dfdvz,dfdvp,f,dfdv
	real*8 vz,vv,vz0
	real*8 lnpsd,lnpsd0,dlnpsddvz,dlnpsddvp
      real*8 signvz
	integer*4 dimarr(10)
      integer*4 iVZ,iVP
      real*8 para_bimax(10)
      real*8 vzi,vpi,fi,dfdvzi,dfdvpi
      integer*4 icall
      data icall/0/
      save icall

      real*8 THISVZnew(NVZ1),THISVPnew(NVP1)
      real*8 THISLNPSDnew(NVZ1,NVP1)
      real*8 VZminnew,VZmaxnew
      real*8 VPminnew,VPmaxnew
      common /dfvzvpdata/ THISVZnew,THISVPnew,THISLNPSDnew,
     1      VZminnew,VZmaxnew,VPminnew,VPmaxnew 
      if(icall.eq.0) then
              call logspace(THISVPnew,1d1,1d8,NVP1)
              do iVP=1,NVP1
                  THISVZnew(NVP1+iVP)=THISVPnew(iVP)
                  THISVZnew(NVP1-iVP+1)=THISVPnew(iVP)*(-1d0)
              enddo
              para_bimax(1:9)=(/1.0,1.0,4.0e5,20e3,25e3,
     1   -1.0,-1.0,0.9088,0.0/)
              do iVZ=1,NVZ1
              do iVP=1,NVP1
                  vzi=THISVZnew(iVZ)
                  vpi=THISVPnew(iVP)
                  call bimax(vzi,vpi,fi,dfdvzi,dfdvpi,para_bimax)
                  if(fi.gt.1d-200) then
                        THISLNPSDnew(iVZ,iVP)=dlog(fi)
                  else
                        THISLNPSDnew(iVZ,iVP)=-200d0 ! avoid dlog(0.0d0)
                  endif
              enddo
              enddo
c                        write(*,*)vzi,vpi,fi,dfdvzi,dfdvpi,para_bimax
c                        write(*,*)dlog(fi)
c                        stop
            VZminnew=THISVZnew(1)
            VZmaxnew=THISVZnew(NVZ1)
            VPminnew=THISVPnew(1)
            VPmaxnew=THISVPnew(NVP1)

      
      endif
	dimarr(1)=NVZ1
	dimarr(2)=NVP1
	dimarr(3)=NVZ1
	dimarr(4)=NVP1
     


      signvz=1.0d0
c      if(vz0.lt.0.0d0) signvz=-1.0d0
c      if(vz0.eq.0.0d0) signvz=0.0d0
      vz=signvz*vz0

      if((vz.ge.VZminnew).and.(vz.le.VZmaxnew).and.
     1   (vp.ge.VPminnew).and.(vp.le.VPmaxnew)) then
	call linearinterp2d(THISVZnew,THISVPnew,THISLNPSDnew,vz,vp,
     1    lnpsd,dlnpsddvz,dlnpsddvp,dimarr)
      else
            lnpsd=-100.0d0
            dlnpsddvz=0.0d0
            dlnpsddvp=0.0d0
      endif

	f=dexp(lnpsd)  
	dfdvz=f*dlnpsddvz*signvz 
	dfdvp=f*dlnpsddvp  
      icall=icall+1
      end

