	subroutine PIG_INIT
c     Initialization
	use mod_PhyConst
	use mod_WavesWork
	implicit none
c     ZEROARR is used for initial any new varible      
      ZEROARR=0.0d0
c     default range of harmonic number  
	MH0=MHm0
	MH1=MHm1
c     setup integration steps      
      NVP=NVPMAX
      call PIG_TEST_OFF
      end

      subroutine PIG_TEST_ON(testfile)
	use mod_WavesWork
	implicit none
      character*(*) testfile
c     LGR testmode =1 output
c     weighting factor
c     dfdvp dfdvz
      LGR_testmode=1
      LGR_testfile=testfile
      end

      subroutine PIG_TEST_OFF
	use mod_WavesWork
	implicit none
c     LGR testmode =1 output
c     weighting factor
c     dfdvp dfdvz
      LGR_testmode=0
      LGR_testfile='LGR_test.bin'
      end


      subroutine PIG_SETUP(iq,imas,vzmin,vzmax,
     1  vpmin,vpmax,vpscalein,nvpnew)
c     setup      
c	THISiq and THISimas
c     THISVZRESMAX,THISVZRESMIN
c     THISVPMIN,THISVPMAX
c     VPARR and DVPARR    
c	
c	vpscale: lin or log
	use mod_PhyConst
	use mod_WavesWork
      implicit none
      integer*4 iq,imas
      integer*4 ivp
      integer*4 nvpnew
      real*8 logdvp,rdvp
	real*8 vzmin,vzmax,vpmin,vpmax
	character*(*) vpscalein
      character*3 vpscale

      THISiq=dble(iq)
      if(imas .eq. 0) then
            THISimas=memp
      else
            THISimas=dble(imas)
      endif

      THISVZRESMAX=vzmax
      THISVZRESMIN=vzmin
      THISVPMAX=vpmax
      THISVPMIN=vpmin
      vpscale=vpscalein(1:3)
      NVP=nvpnew
            

c     setup VPARR and DVPARR      
      if(vpscale.eq.'lin') then
      do 10 ivp=1,NVP
            VPARR(ivp)=(THISVPMAX-THISVPMIN)/(NVP-1.0)*ivp+THISVPMIN
            DVPARR(ivp)=(THISVPMAX-THISVPMIN)/(NVP-1.0)
 10   continue     
      else
c     log spacing in vp
      logdvp=dlog10(THISVPMAX/THISVPMIN)/(NVP-1)
      rdvp=10.0**(logdvp)
      do 11 ivp=1,NVP
            VPARR(ivp)=THISVPMIN*10.0**(logdvp*(dble(ivp)-1.0d0))
            DVPARR(ivp)=VPARR(ivp)*(rdvp-1.0d0)
 11   continue     
      endif
      end


      subroutine PIG_SETUP_SPECIESid(iS)
      implicit none
      integer*4 iq,imas,iS
      if (iS.eq.1) then
              iq=1
              imas=1
      elseif (iS.eq.2) then
              iq=1
              imas=4
      elseif (iS.eq.3) then
              iq=1
              imas=16
      elseif (iS.eq.4) then
              iq=-1
              imas=0
      else
              stop
      endif

      call PIG_SETUP_SPECIES(iq,imas)

      end subroutine

      subroutine PIG_SETUP_SPECIES(iq,imas)
c     setup      
c	THISiq and THISimas
c     THISVZRESMAX,THISVZRESMIN
c     THISVPMIN,THISVPMAX
c     VPARR and DVPARR    
	use mod_PhyConst
	use mod_WavesWork
      implicit none
      integer*4 iq,imas
      integer*4 ivp
      real*8 logdvp,rdvp
      character*3 vpscale

      THISiq=dble(iq)
      if(imas .eq. 0) then
            THISimas=memp
      else
            THISimas=dble(imas)
      endif

      if( (iq.eq.(-1)) .and. imas.eq.0) then
            THISVZRESMAX=3e8
            THISVZRESMIN=-1.0*THISVZRESMAX
            THISVPMAX=3e8
            THISVPMIN=1e1
            vpscale='log'
            vpscale='lin'
            
      elseif (iq.eq.1) then
            THISVZRESMAX=3.9149e7/sqrt(imas*1.0)
            THISVZRESMIN=-1.0*THISVZRESMAX
            THISVPMAX=1e7/sqrt(imas*1.0)
            THISVPMIN=1e1
            vpscale='log'
c            vpscale='lin'
      else
      endif

c     setup VPARR and DVPARR      
      if(vpscale.eq.'lin') then
      do 10 ivp=1,NVP
            VPARR(ivp)=(THISVPMAX-THISVPMIN)/(NVP-1.0)*ivp+THISVPMIN
            DVPARR(ivp)=(THISVPMAX-THISVPMIN)/(NVP-1.0)
 10   continue     
      else
c     log spacing in vp
      logdvp=dlog10(THISVPMAX/THISVPMIN)/(NVP-1)
      rdvp=10.0**(logdvp)
      do 11 ivp=1,NVP
            VPARR(ivp)=THISVPMIN*10.0**(logdvp*(dble(ivp)-1.0d0))
            DVPARR(ivp)=VPARR(ivp)*(rdvp-1.0d0)
 11   continue     
      endif
      end



	subroutine PIG_ReMatr33(A,B)
	real*8 A(3,3),B(3,3)  

	B(1,1)=(A(3,3)*A(2,2)-A(2,3)*A(3,2))
	B(1,2)=(A(3,1)*A(2,3)-A(2,1)*A(3,3))
	B(1,3)=(A(3,2)*A(2,1)-A(2,2)*A(3,1))
	B(2,1)=(A(3,2)*A(1,3)-A(1,2)*A(3,3))
	B(2,2)=(A(3,3)*A(1,1)-A(1,3)*A(3,1))
	B(2,3)=(A(3,1)*A(1,2)-A(1,1)*A(3,2))
	B(3,1)=(A(1,2)*A(2,3)-A(1,3)*A(2,2))
	B(3,2)=(A(1,3)*A(2,1)-A(1,1)*A(2,3))
	B(3,3)=(A(1,1)*A(2,2)-A(1,2)*A(2,1))
	end
      



      function matchind(arr,ist,narr,val) result(ind)
      implicit none
      real*8, intent(in):: arr(*), val
      integer*4, intent(in) :: narr
      integer*4 ind,i,ist
      real*8 diff1,diff
      diff=1d99

      do 10 i=ist,ist+narr-1
            diff1=abs(arr(i)-val)
            if(diff1.lt.diff) then
                  ind=i
                  diff=diff1
            endif
 10   continue    
      end 

      function matchindp(arr,ist,narr,pd,val) result(ind)
      implicit none
      real*8, intent(in):: arr(*), val,pd
      integer*4, intent(in) :: narr
      integer*4 ind,i,ist
      real*8 diff1,diff,rdiff
      diff=1d99

      do 10 i=ist,ist+narr-1
            diff1=abs(dmod(arr(i)-val,pd))
            if(diff1.gt.pd*0.5d0) diff1=pd-diff1
c            write(*,*) diff1
c            diff1=abs(dmod(2*pd+arr(i)-val,pd))
c            diff1=dmod(abs(arr(i)-val),pd)
            if(diff1.lt.diff) then
                  ind=i
                  diff=diff1
            endif
 10   continue    
      end 

