	module mod_RAM
	implicit none
c	size of F0 (six dimensions)
c	NE0: number of energy channel
c	NPA0: number of pitch angles
c	NVP: number of vp values for integration
c	NSP: number of species
c	NL: the number of L grid in PSD data
c	NMLT: number of MLT grid in PSD data
c	NLn: the number of L grid in density data
c	NMLTn: number of MLT grid in density data



	integer*4 NE0,NPA0
	integer*4 NSP
	integer*4 NMLT,NL,NT
      integer*4 NLn,NMLTn

	parameter(NE0=29,NPA0=69)
	parameter(NSP=3)
	parameter(NL=17,NMLT=24,NT=2)
      parameter(NLn=19,NMLTn=25)



c	following four not used yet
c	integer*4 iSPs(NSP),iTs(NT)  
c	integer*4 iLs(NSP),iMLTs(NT)  
	  
	real*8 SPs(NSP),Ts(NT)  
	real*8 Ls(NL),MLTs(NMLT)  
	real*8 PA0(NPA0),E0(NE0),MU0s(NPA0)
	real*8 PA0MAX,PA0MIN 
	real*8 E0MAX,E0MIN
	real*8 dLs(NL),dMLTs(NMLT)  
	real*8 dPA0s(NPA0),dE0s(NE0),dMU0s(NPA0)

	real*8 PSD0(NT,NSP,NL,NMLT,NE0,NPA0)
	real*8 FLUX0(NT,NSP,NL,NMLT,NE0,NPA0)
	common/PIGALLRAMDATA/
     1	PA0,E0,
     2	PSD0,FLUX0,
     3	Sps,Ts,Ls,MLTs,
     4	PA0MAX,PA0MIN,
     5	E0MAX,E0MIN,
     6	dLs,dMLTs,dPA0s,dE0s

	integer*4 THISCASEARR(4) 
      real*8 THISFLUX(NE0,NPA0),THISPSD(NE0,NPA0) 
	real*8 THISLNPSD(NE0,NPA0)
	integer*4 THISiT,THISiSP,THISiL,THISiMLT  
	real*8 THISrT,THISrSP,THISrL,THISrMLT  
	real*8 THISNETOT2D(NLn,NMLTn),THISNE  
	integer*4 THISiLn,THISiMLTn
	real*8 THISWPE,THISWCE,THISBB
	real*8 THISE0(NE0),THISPA0(NPA0),THISVV(NE0)
	real*8 THISSPA0(NPA0),THISSPA0MIN,THISSPA0MAX
	common/PIGTHISDATA/
     1	ThisiT,ThisiSP,THISiL,THISiMLT,  	
     2	THISrT,THISrSP,THISrL,THISrMLT,  
     3	THISFLUX,THISPSD,THISCASEARR,
     4	THISLNPSD,
     7	THISNETOT2D,THISiLn,THISiMLTn,
     8	THISNE,
     9	THISE0,THISPA0,THISVV,THISSPA0
     1	,THISSPA0MIN,THISSPA0MAX
     2	,THISWCE,THISWPE,THISBB
      

	character THISCASESTR*100
	integer*4 THISNCASESTR
      common/STRDATA/THISCASESTR,THISNCASESTR


	real*8 IQARR(4),IMASARR(4)  
	common/SPECIESDATA/
     1	IQARR,IMASARR	



      real*8 Lns(NLn),MLTns(NMLTn),NETOT(NT,NLn,NMLTn)
	common/DENDATA/Lns,MLTns,NETOT



      integer*4 NVDF,NPADF
      parameter(NVDF=NE0,NPADF=NPA0*2+2)
      real*8 THISVVnew(NVDF),THISPAnew(NPADF)
      real*8 THISLNPSDnew(NVDF,NPADF)
      real*8 VVminnew,VVmaxnew
      real*8 PAminnew,PAmaxnew
      common /dframXdata/ THISVVnew,THISPAnew,THISLNPSDnew,
     1      VVminnew,VVmaxnew,PAminnew,PAmaxnew 
      end module mod_RAM



      subroutine RAM_INIT
	use mod_RAM
	use mod_PhyConst
	implicit none

	integer*4 iL,iMLT,ivp,isp,iPA
	SPs=(/1,2,3/)
	Ts=(/40,48/)
	IQARR=(/1.0,1.0,1.0,-1.0/)  
	IMASARR=(/1.0d0,4.0d0,16.0d0,memp/)  
	call READ_RAMFLUX_ALL
      call RAM_DVOL
      PA0MIN=PA0(1)
      PA0MAX=PA0(NPA0)
      E0MIN=E0(1)
      E0MAX=E0(NE0)
c      write(*,*) PA0MIN,PA0MAX,E0MIN,E0MAX
c     
c     load Ln, MLTn, NETOT
	call READ_NE(int4(1),'apr_01_ne_d3_RCME.dat')
	call READ_NE(int4(2),'apr_01_ne_04_RCME.dat')
	end



      subroutine RAM_SETUP(iT,iSp,rL,rMLT)
      use mod_PhyConst
      use mod_RAM
      use mod_WavesWork
      implicit none

      integer*4 icase(4)
      integer*4 iT,iSp,i
      real*8 rL,rMLT
      real*8 logdvp,rdvp
      integer*4 ivp,iE,iPA,iVV
      real*8 vz,vp,f,dfdvz,dfdvp
      real*8 para_bimax(10)

      icase(1)=iT
      icase(2)=iSp
      call RAM_geticase(rL,0.0d0,rMLT*15.0d0,icase)
      THISiT=icase(1)
      THISiSP=icase(2)
      THISiL=icase(3)
      THISiMLT=icase(4)
      THISrT=Ts(THISiT)
      THISrL=Ls(THISiL)
      THISrMLT=MLTs(THISiMLT)
      THISiq=IQARR(ThisiSP)
      THISimas=IMASARR(ThisiSP)
      THISE0=E0
      THISPA0=PA0
      THISVV=dsqrt(2.0d0*THISE0*ev*1e3/(THISimas*hmas))
c  SPA0 not needed ????      
      THISSPA0=dsin(THISPA0*pi/180.0d0)
      THISSPA0MIN=THISSPA0(1)
      THISSPA0MAX=THISSPA0(NPA0)

c      write(*,*) icase
c      write(*,*) THISrL,THISrMLT,THISiq,THISimas,THISiT,THISiSP
c      write(*,*) THISVV

      THISVZRESMAX=THISVV(NE0)
      THISVZRESMIN=-1.0*THISVZRESMAX
      THISVPMAX=THISVV(NE0)
c     THISVPMIN might be less than THISVV(1)       
c     THISVPMAX generally equal to THISVV(NE0)
c      THISVPMIN=THISVV(1)
      THISVPMIN=1e1

c     SETUP RAM PSD
      if (THISiSP.lt.4) then! for ions
      do 20 iE=1,NE0
      THISPSD(iE,1:NPA0)=PSD0(THISiT,THISiSP,THISiL,THISiMLT,iE,1:NPA0)
      THISLNPSD(iE,1:NPA0)=dlog(THISPSD(iE,1:NPA0))
 20   continue
c    dealing with PSD trough near PA ~ 90 deg
      THISPSD(1:NE0,NPA0)=THISPSD(1:NE0,NPA0-1)
      THISLNPSD(1:NE0,NPA0)=THISLNPSD(1:NE0,NPA0-1)
      else ! for electron
      endif

      if (1.eq.0) then ! modification on PSD
              do iE=1,8
                  THISPSD(iE,:)=THISPSD(9,:)
                  THISLNPSD(iE,:)=THISLNPSD(9,:)
              enddo
      endif
      if (1.eq.0) then ! test Horne 2000 Ring-type PSD
      do iE=1,NE0
      do iPA=1,NPA0
        vz=THISVV(iE)*dcos(THISPA0(iPA)*rad)
        vp=THISVV(iE)*dsin(THISPA0(iPA)*rad)
        para_bimax(1:9)=(/1.0,1.0,4.0e5,20e3,25e3,
     1   -1.0,-1.0,0.9088,0.0/)
        call bimax(vz,vp,f,dfdvz,dfdvp,para_bimax)
            THISPSD(iE,iPA)=f
            THISLNPSD(iE,iPA)=dlog(f)
      enddo
      enddo
      endif





c     ******************************************************
c update the dframXdata for calling dframX      
c     ******************************************************
              THISVVnew(1:NVDF)=THISVV(1:NE0)
              THISPAnew(1)=0.0d0
              THISPAnew(NPADF)=dacos(-1.0d0)
              THISLNPSDnew(1:NVDF,1)=THISLNPSD(1:NE0,1)
              THISLNPSDnew(1:NVDF,NPADF)=THISLNPSD(1:NE0,1)
              do iPA=1,NPA0
                  THISPAnew(iPA+1)=THISPA0(iPA)*rad
                  THISPAnew(NPADF-iPA)=pi-THISPA0(iPA)*rad
              enddo
              do iVV=1,NVDF
              do iPA=1,NPA0
                       THISLNPSDnew(iVV,iPA+1)=THISLNPSD(iVV,iPA)
                       THISLNPSDnew(iVV,NPADF-iPA)=THISLNPSD(iVV,iPA)
              enddo
              enddo
            VVminnew=THISVVnew(1)
            VVmaxnew=THISVVnew(NVDF)
            PAminnew=THISPAnew(1)
            PAmaxnew=THISPAnew(NPADF)




c     ******************************************************
c     linear spacing in vp
c      do 10 ivp=1,NVP
c            VPARR(ivp)=(THISVPMAX-THISVPMIN)/(NVP-1.0)*ivp+THISVPMIN
c            DVPARR(ivp)=(THISVPMAX-THISVPMIN)/(NVP-1.0)
c 10   continue     

c     log spacing in vp
      logdvp=dlog10(THISVPMAX/THISVPMIN)/(NVP-1)
      rdvp=10.0**(logdvp)
      do 11 ivp=1,NVP
            VPARR(ivp)=THISVPMIN*10.0**(logdvp*(dble(ivp)-1.0d0))
            DVPARR(ivp)=VPARR(ivp)*(rdvp-1.0d0)
 11   continue     
 




c     SETUP DENSITY      
      THISiLn=THISiL+2
      THISiMLTn=THISiMLT
      THISNE=NETOT(THISiT,THISiLn,THISiMLTn) ! in m-3
      THISNETOT2D=NETOT(THISiT,1:NLn,1:NMLTn)
c      write(*,*) THISNE
      THISWPE=dsqrt(THISNE*ev*ev/emas/ee0)
      THISBB=BBeq/THISrL**3
      THISWCE=ev*THISBB/emas
      write(THISCASESTR,51) THISrT,THISiSP,THISrL,THISrMLT
  51  format(BZ,'T',f4.1,'SP',i1.1,'L',f4.2,'MLT',f4.1,BN)
      THISNCASESTR=LEN_TRIM(THISCASESTR)
      do 60 i=1,THISNCASESTR
            if(THISCASESTR(i:i).eq. ' ') then
                    THISCASESTR(i:i)='0'
            endif
  60  continue
      end



      subroutine RAM_SETUPNE(iT,iSp,rL,rMLT)
      use mod_PhyConst
      use mod_RAM
      use mod_WavesWork
      implicit none
      integer*4 icase(4)
      integer*4 iT,iSp,i
      real*8 rL,rMLT
      real*8 logdvp,rdvp
      integer*4 ivp,iE,iPA
      real*8 vz,vp,f,dfdvz,dfdvp
      real*8 para_bimax(10)
      icase(1)=iT
      icase(2)=iSp
      call RAM_geticase(rL,0.0d0,rMLT*15.0d0,icase)
      THISiT=icase(1)
      THISiSP=icase(2)
      THISiL=icase(3)
      THISiMLT=icase(4)
      THISrT=Ts(THISiT)
      THISrL=Ls(THISiL)
      THISrMLT=MLTs(THISiMLT)

c     SETUP DENSITY      
      THISiLn=THISiL+2
      THISiMLTn=THISiMLT
      THISNE=NETOT(THISiT,THISiLn,THISiMLTn) ! in m-3
      THISNETOT2D=NETOT(THISiT,1:NLn,1:NMLTn)
c      write(*,*) THISNE
      THISWPE=dsqrt(THISNE*ev*ev/emas/ee0)
      THISBB=BBeq/THISrL**3
      THISWCE=ev*THISBB/emas
      end



	subroutine READ_RAMFLUX_ALL
c     RCME + Young et al for ion composition      
c	call READ_RAMFLUX(int4(1),int4(1),'ardd3_h.flx_RCME_high_fort')
c	call READ_RAMFLUX(int4(1),int4(2),'ardd3he.flx_RCME_high_fort')
c	call READ_RAMFLUX(int4(1),int4(3),'ardd3_o.flx_RCME_high_fort')
c	call READ_RAMFLUX(int4(2),int4(1),'ard04_h.flx_RCME_high_fort')
c	call READ_RAMFLUX(int4(2),int4(2),'ard04he.flx_RCME_high_fort')
c	call READ_RAMFLUX(int4(2),int4(3),'ard04_o.flx_RCME_high_fort')
c	call SAVE_PSD_RAM_ALL('RAM_output/RCME_fort.bin')
c	call LOAD_PSD_RAM_ALL('RAM_output/RCME_fort.bin')



c     RCME + Young et al & Daglis et al for ion composition      
c     2009/10/22 Los Alamos
c	call READ_RAMFLUX(int4(1),int4(1),'RAM_output/argd3_h.flx_20091022')
cc	call READ_RAMFLUX(int4(1),int4(2),'')
c	call READ_RAMFLUX(int4(1),int4(3),'RAM_output/argd3_o.flx_20091022')
c	call READ_RAMFLUX(int4(2),int4(1),'RAM_output/arg04_h.flx_20091022')
cc	call READ_RAMFLUX(int4(2),int4(2),'')
c	call READ_RAMFLUX(int4(2),int4(3),'RAM_output/arg04_o.flx_20091022')
c	call SAVE_PSD_RAM_ALL('RAM_output/arg_flx_fort.bin_20091022')
	call LOAD_PSD_RAM_ALL('RAM_output/arg_flx_fort.bin_20091022')
	end subroutine




	subroutine READ_RAMFLUX(iT,iSpec,fluxfile)
c     read flux file from RAM      
      use mod_PhyConst
      use mod_RAM
	implicit none

	integer*4 iT,iSpec
	character fluxfile*(*)

	real*8 MLT,L,T0
	real*8 PADistx(NPA0)
	integer*4 iw3,iw2
	integer*4 iE,iL,iMLT,iPA
	real*8 thisfac
      real*8 PA0_tmp(NPA0)


c     L and MLT grid info from RAM      
c	do 10 iL=1,NL  
c		Ls(iL)=2.5+(iL-1.0)*0.25  
c 10	continue		
c	do 20 iMLT=1,NMLT  
c		MLTs(iMLT)=(iMLT-1.0)*1.0  
c 20	continue		


c Pitch Angle Array
	PA0_tmp=(/   
     1	88.23,86.49,84.78,
     2	83.10,81.45,79.83,78.23, 
     3	76.65,75.10,73.56,72.05,
     4	70.55,69.07,67.60,66.15,
     5	64.71,63.28,61.86,60.46,
     6	59.06,57.67,56.28,54.91,
     7	53.53,52.16,50.80,49.43,
     8	48.06,46.70,45.33,43.95, 
     9	42.57,41.18,39.77,38.36, 
     1	36.93,35.48,34.00,32.50, 
     2	30.97,29.40,27.78,26.11, 
     3	24.36,22.53,20.59,18.70,
     4	17.21,16.00,14.11,11.86, 
     5	10.16,8.83, 7.78, 6.92, 
     6	6.20,5.61, 5.10 ,4.67, 
     7	4.29,3.96, 3.67 ,3.42,  
     8	3.19,2.99, 2.81 ,2.64, 
     9	2.50,1.50 /)
c Ptich Angle with ascendant order     
      do 21 iPA=1,NPA0
            PA0(iPA)=PA0_tmp(NPA0-iPA+1)
 21   continue     







	iw2=11
      write(*,*) 'reading ',fluxfile
      open(unit=iw2,file=fluxfile,
     1	form='formatted',status='unknown')

c     setup fac to convert flux to psd
c     note energy in unit of kev
	if(iSpec.eq.1) thisfac=Hfac
	if(iSpec.eq.2) thisfac=Hefac
	if(iSpec.eq.3) thisfac=Ofac


	do 30 iL=1,NL
	do 20 iMLT=1,NMLT
		read(iw2,*) T0,L,MLT
c		write(*,*) T0,L,MLT
		MLTs(iMLT)=MLT
		Ls(iL)=L
            Ts(iT)=T0
  	do 10 iE=1,NE0
		read(iw2,*) E0(iE),PADistx
		do 40 iPA=1,NPA0
c     change the order of PA => ascendant order            
			FLUX0(iT,iSpec,iL,iMLT,iE,iPA)=PADistx(NPA0+1-iPA)
			PSD0(iT,iSpec,iL,iMLT,iE,iPA)=
     1		FLUX0(iT,iSpec,iL,iMLT,iE,iPA)*thisfac/E0(iE)
  40		continue	  
  10	continue	 
  20	continue	 
  30	continue	 
  	close(iw2)
	end subroutine


      subroutine RAM_DVOL
      use mod_PhyConst
      use mod_RAM
      implicit none
      integer*4 iL,iMLT,iE,iPA

      do iL=1,NL
            if(iL.eq.1) then
                  dLs(iL)=(Ls(2)-Ls(1))*0.5
            elseif(iL.eq.NL) then
                  dLs(iL)=(Ls(NL)-Ls(NL-1))*0.5
            else
                  dLs(iL)=(Ls(iL+1)-Ls(iL-1))*0.5
            endif
      enddo

c     uniform and periodical MLT grid      
      do iMLT=1,NMLT
            dMLTs(iMLT)=MLTs(2)-MLTs(1)
      enddo

      do iE=1,NE0
            if(iE.eq.1) then
                  dE0s(iE)=(E0(2)-E0(1))*0.5
            elseif(iE.eq.NE0) then
                  dE0s(iE)=(E0(NE0)-E0(NE0-1))*0.5
            else
                  dE0s(iE)=(E0(iE+1)-E0(iE-1))*0.5
            endif
      enddo
      MU0s=cos(PA0*rad)
c     PA0: 0 - 90
c     MU0: cos(PA0) 
c     dMU0s = |d mu|, always positve
      do iPA=1,NPA0
            if(iPA.eq.1) then
                  dPA0s(iPA)=(PA0(2)+PA0(1))*0.5-0.0
                  dMU0s(iPA)=1-(MU0s(1)+MU0s(2))*0.5
            elseif(iPA.eq.NPA0) then
                  dPA0s(iPA)=90-(PA0(NPA0)+PA0(NPA0-1))*0.5
                  dMU0s(iPA)=(MU0s(NPA0)+MU0s(NPA0-1))*0.5-0.0
            else
                  dPA0s(iPA)=(PA0(iPA+1)-PA0(iPA-1))*0.5
                  dMU0s(iPA)=(MU0s(iPA-1)-MU0s(iPA+1))*0.5
            endif
      enddo
      write(*,*) 'dLs', dLs
      write(*,*) 'dMLTs', dMLTs
      write(*,*) 'dEs', dE0s
      write(*,*) 'dPAs', dPA0s
      end



      subroutine RAM_MOMENT
      use mod_PhyConst
      use mod_RAM
      implicit none
      integer*4 iT,iSP,iL,iMLT,iE,iPA
      real*8 vvs(NE0),pas(NPA0),dvv,dpa,dvvs(NE0)
      real*8 core
      real*8 dencore,den
      real*8 Tperpcore,Tperp
      real*8 Tparacore,Tpara
      real*8 denarr(NT,NSP,NL,NMLT)
      real*8 Tperparr(NT,NSP,NL,NMLT)
      real*8 Tparaarr(NT,NSP,NL,NMLT)
      real*8 dpadvv,dxdydz
      real*8 TotE(NT,NSP),BPert(NT,NSP)
      real*8 hy,y,alphay,betay,a1y,a2y,a3y,a4y
      real*8 mt,Q,cPAlc,L
      integer*4 fid

c     coefficient for calculating h(y) Jordanova PhD Thesis P50
c     where y=sin(PA0)
      alphay=1.38
      betay=0.32
      a1y=0.055
      a2y=-0.037
      a3y=-0.074
      a4y=0.056

c     PSD0(NT,NSP,NL,NMLT,NE0,NPA0)
      denarr=0
      Tperparr=0
      Tparaarr=0
      TotE=0
      do iT=1,NT
      do iSP=1,NSP
            mt=IMASARR(iSP)*hmas
            vvs=dsqrt(2.0d0*E0*ev*1e3/mt)
            dvvs=dE0s/E0/2*vvs
            pas=PA0*rad
      do iL=1,NL
      do iMLT=1,NMLT
            den=0
            Tperp=0
            Tpara=0
      do iE=1,NE0
            dvv=dvvs(iE)
      do iPA=1,NPA0
            y=sin(pas(iPA))
            hy=alphay-betay*(y+y**(1./2.))
     1        +a1y*y**(1./3.)+a2y*y**(2./3.)+a3y*y+a4y*y**(4./3.)
            Q=PSD0(iT,iSP,iL,iMLT,iE,iPA)/mt**3
            cPAlc=sqrt(1-1.0/L**3/sqrt(4.0-3.0/L))

            dpa=dPA0s(iPA)*rad
            core=4*pi*PSD0(iT,iSP,iL,iMLT,iE,iPA)
     1       *vvs(iE)*vvs(iE)*dsin(pas(iPA))
            dencore=core
            dpadvv=dpa*dvv
            dxdydz=Ls(iL)*dMLTs(iMLT)*dLs(iL)*pi/12*RE**3




c     kTp=1/2 m vp**2; kTz/2 =1/2 m vz**2           
            Tperpcore=core*E0(iE)*dsin(pas(iPA))**2
            Tparacore=2*core*E0(iE)*dcos(pas(iPA))**2
            den=den+dencore*dpadvv
c     Temperature and energy in unit of keV            
            Tperp=Tperp+Tperpcore*dpadvv
            Tpara=Tpara+Tparacore*dpadvv
            TotE(iT,iSP)=TotE(iT,iSP)+core*E0(iE)*dpadvv*dxdydz
      enddo
      enddo
            denarr(iT,iSP,iL,iMLT)=den
            Tperparr(iT,iSP,iL,iMLT)=Tperp/den
            Tparaarr(iT,iSP,iL,iMLT)=Tpara/den
      enddo
      enddo
            
      enddo
      enddo
c     Jordanova PhD Thesis P67 (3.59)      
      BPert=TotE*(3.98e-30)
      write(*,10) BPert(1:2,1:3:2)
  10  format('B Pertubation in nT (t=40,48hr):',/,
     1       'H+ contribution:',g14.5,2x,g14.5,/,
     2       'O+ contribution:',g14.5,2x,g14.5)    
      fid=61
c	call open_bin(fid,'./RAM_output/RAM_MOMENT_Y81.bin')
c	call open_bin(fid,'./RAM_output/RAM_MOMENT_D93.bin')
	call open_bin(fid,'./RAM_output/RAM_MOMENT.bin')
      write(fid) NT,NSP,NL,NMLT
      write(fid) Ts,SPs,Ls,MLTs
      write(fid) denarr,Tperparr,Tparaarr
      close(fid)
	call open_bin(fid,'./RAM_output/RAM_MOMENT_PSD.bin')
      write(fid) NT,NSP,NL,NMLT,NE0,NPA0
      write(fid) Ts,SPs,Ls,MLTs,E0,PA0
      write(fid) PSD0
      close(fid)

      end subroutine

	subroutine SAVE_PSD_RAM_ALL(filename)
      use mod_RAM
	implicit none
	character filename*(*)
	integer*4 iw3  
	iw3=13
      open(unit=iw3,file=filename,
c     1	form='stream',status='unknown')
c     1	form='binary',status='unknown')
     1	form='unformatted',status='unknown')

	write(iw3) NT,NSP,NL,NMLT,NE0,NPA0
     	write(iw3) Ts,SPs,Ls,MLTs,E0,PA0
	write(iw3) FLUX0,PSD0 
	close(iw3)

c	print*,'FLUX0,PSD0 from save_psd'  
c	print*,FLUX0(1,1,1,1,1,1:NPA0)
c	print*,PSD0(1,1,1,1,1,1:NPA0)
	end subroutine

	subroutine LOAD_PSD_RAM_ALL(filename)
      use mod_RAM
	implicit none
	character filename*(*)

	integer*4 ir3
	integer*4 rNT,rNL,rNMLT,rNE0,rNPA0,rNSP
	ir3=13
c	call open_unfmt(ir3,'./test.dat')
      open(unit=ir3,file=filename,
c     1	form='stream',status='unknown')
c     1	form='binary',status='unknown')
     1	form='unformatted',status='unknown')
c	cannot updata the value of Nxx   
	read(ir3) rNT,rNSP,rNL,rNMLT,rNE0,rNPA0
     	read(ir3) Ts,SPs,Ls,MLTs,E0,PA0
	write(*,*)rNT,rNSP,rNL,rNMLT,rNE0,rNPA0
     	write(*,*) Ts,SPs,Ls,MLTs,E0,PA0
	read(ir3) FLUX0,PSD0 
	close(ir3)
c	print*,'FLUX0,PSD0 from load_psd'  
c	print*,FLUX0(1,1,1,1,1,1:NPA0)
c	print*,PSD0(1,1,1,1,1,1:NPA0)
	end subroutine

	subroutine LOAD_PSD_RAM_CASE(icase)
c     not used yet      
      use mod_RAM
	implicit none
	integer*4 icase(4)  
	THISCASEARR=icase
	THISiT=THISCASEARR(1)
	THISiSp=THISCASEARR(2)
	THISiL=THISCASEARR(3)
	THISiMLT=THISCASEARR(4)

	THISFLUX=FLUX0(THISiT,ThISiSP,THISiL,THISiMLT,1:NE0,1:NPA0)  
	THISPSD=PSD0(THISiT,THISiSP,THISiL,THISiMLT,1:NE0,1:NPA0)  

	end subroutine

      subroutine READ_NE(iT,filename)
      use mod_PhyConst
      use mod_RAM
      implicit none
      character filename*(*)
      integer*4 iw3,iT,i,j
      iw3=14
      open(unit=iw3,file=filename,
     1	form='formatted',status='unknown')
      read(iw3,'(a)')
      do 10 i=1,NLn
      do 20 j=1,NMLTn
            read(iw3,*) Lns(i),MLTns(j),NETOT(iT,i,j)
            MLTns(j)=MLTns(j)*12.0/pi
            NETOT(iT,i,j)=NETOT(iT,i,j)*1d6
  20  continue    
  10  continue    
      close(iw3)
      

      end
      subroutine findmin(Ys,y,ny,indmin)
      implicit none
c     for monotonous increasing Ys      
      real*8 Ys(*),y
      integer*4 ny,i
      integer*4 indmin
      real*8 dy
      if(y.lt.((Ys(1)+Ys(2))*0.5)) then
              indmin=1
              go to 11
      endif
      if(y.ge.((Ys(ny-1)+Ys(ny))*0.5)) then
              indmin=ny
              go to 11
      endif
      do 10 i=2,ny-1
c            dy=(Ys(2)-Ys(1))*0.5
            if(((Ys(i-1)+Ys(i))*0.5.le.y).and.
     1       (y.lt.((Ys(i)+Ys(i+1))*0.5)))then
                  indmin=i
                  go to 11 
            endif
 10   continue     
 11   continue     
      end

      subroutine findminT(Ys,y,ny,indmin,TY)
      implicit none
c     for periodic Ys with period TY      
      real*8 Ys(*),y,TY
      integer*4 ny,indmin,i
      real*8 dy
      if((y.lt.((Ys(1)+Ys(2))*0.5)).and.
     1  (y.ge.0))then
              indmin=1
              go to 11
      endif
      if((y.ge.((Ys(ny-1)+Ys(ny))*0.5)).and.
     1  (y.le.TY)) then
              indmin=ny
              go to 11
      endif
      do 10 i=2,ny-1
c            dy=(Ys(2)-Ys(1))*0.5
            if(((Ys(i-1)+Ys(i))*0.5.le.y).and.
     1       (y.lt.((Ys(i)+Ys(i+1))*0.5)))then
                  indmin=i
                  go to 11 
            endif
 10   continue     
 11   continue     
      end

      subroutine RAM_geticase(rrr,lat,fid,icase)
      use mod_PhyConst
      use mod_RAM
      implicit none
      real*8 T,rrr,lat,fid
      integer*4 icase(4)
      integer*4 indT,indL,indMLT,indlat
      real*8 Lx,MLTx,dMLT,dL
      integer*4 iMLT,iL
c      indT=MINLOC(dabs(Ts-T))

      Lx=rrr*dcos(lat*rad)**2
      MLTx=fid*24./360.0

c      write(*,*) Lx, MLTx
      if(Lx.lt.Ls(1)) then
            indL=1
      elseif(Lx.gt.Ls(NL)) then
            indL=NL
      else
            dL=(Ls(2)-Ls(1))*0.5
      do 10 iL=1,NL
            if(dabs(Lx-Ls(iL)).le.dL) then
                    indL=iL
                    go to 11
            endif
  10  continue 
  11  continue
      endif
      
      dMLT=(MLTs(2)-MLTs(1))*0.5
c     Note MLT is peroidic azimuthally      
      if((MLTx-MLTs(NMLT)).gt.dMLT) then
            indMLT=1
            go to 21
c      elseif((MLTx-MLTs(1)).lt.dMLT) then
c            indMLT=NMLT
      else
      do 20 iMLT=1,NMLT
            if(dabs(MLTx-MLTs(iMLT)).le.dMLT) then
                    indMLT=iMLT
                    go to 21
            endif
  20  continue 
      endif
  21  continue 
c      indL=MINLOC(dabs(Ls-Lx))
c      indMLT=MINLOC(dabs(MLTs-MLTx))
c      indLat=
      icase(3)=indL
      icase(4)=indMLT
c      write(*,*) '****'
c      write(*,*) rrr,lat,fid
c      write(*,*) icase
c      write(*,*) Lx,MLTx
c      write(*,*) Ls(indL),MLTs(indMLT)
c      write(*,*) MLTs
c      write(*,*) Ls
      end


