      module mod_PIG_CONSTANT
	implicit none
     	integer*4 NSTDOUT,NSTDIN
	parameter(NSTDOUT=6,NSTDIN=5)

c	NMAXWORK : the length of workspace 	  
	integer*4 NMAXWORK
	parameter(NMAXWORK=400)


c	default harmonic resonance range	  
	integer*4 MHm0,MHm1
	parameter(MHm0=-5,MHm1=5)

	integer*4 NMMAX
	parameter(NMMAX=400)

	integer*4 NVPMAX,NMAXLENGTH
	parameter(NVPMAX=10000,NMAXLENGTH=10000)

      end module



	module mod_WavesWork
      use mod_PIG_CONSTANT
	implicit none


	integer*4 MH0,MH1
	real*8 Jms(NMMAX),Jmps(NMMAX),Jmns(NMMAX)  
	common/PIGGROWTHRATE/
     3	Jms,Jmns,Jmps,
     4	MH0,MH1	


c	V MAX and MIN depends on species and its energy 
	real*8 THISiq,THISimas
	real*8 THISVZRESMAX,THISVZRESMIN
	real*8 THISVPMAX,THISVPMIN
	real*8 VPARR(NVPMAX),DVPARR(NVPMAX)  





	integer*4 NVP
      real*8 output_gr(NMAXWORK)
      real*8 input_gr(NMAXWORK)
      common /PIG_GR_OUTPUT/ output_gr,input_gr,
     1	THISiq,THISimas,NVP,
     1	THISVZRESMAX,THISVZRESMIN,
     2	THISVPMAX,THISVPMIN,VPARR,DVPARR

      real*8 output_dr(NMAXWORK)
      real*8 input_dr(NMAXWORK)
      common /PIG_DR_OUTPUT/ output_dr,input_dr

     	real*8 ZEROARR(NMAXLENGTH)
	common/data1/ZEROARR  


	integer*4 mstart,mend,nm  
      real*8, dimension (NMMAX):: gammadDDdwmarr,gammamarr
      real*8, dimension (NMMAX):: kimarr,vresmarr
      common/PIG_GR_DATA/
     1 gammadDDdwmarr,gammamarr,kimarr,vresmarr,
     2 mstart,mend,nm


      real*8 facgrad(NVPMAX,NMMAX,2)
      real*8 PSDgrad(NVPMAX,NMMAX,3)
      real*8, dimension(NVPMAX):: fac11_gradz,fac12_gradz,fac13_gradz,
     1       fac21_gradz,fac22_gradz,fac23_gradz,
     2       fac31_gradz,fac32_gradz,fac33_gradz
      real*8, dimension(NVPMAX):: fac11_gradp,fac12_gradp,fac13_gradp,
     1       fac21_gradp,fac22_gradp,fac23_gradp,
     2       fac31_gradp,fac32_gradp,fac33_gradp

      common /graddata/ facgrad,PSDgrad,
     1 fac11_gradz,fac12_gradz,fac13_gradz,
     2 fac21_gradz,fac22_gradz,fac23_gradz,
     3 fac31_gradz,fac32_gradz,fac33_gradz,
     4 fac11_gradp,fac12_gradp,fac13_gradp,
     5 fac21_gradp,fac22_gradp,fac23_gradp,
     6 fac31_gradp,fac32_gradp,fac33_gradp


c	control parameter
	character psdmdl*6,n2mdl*3,mresmdl*3
	common /ctlpara/ psdmdl,n2mdl,mresmdl


c	Stix Coefficient 
c	BSTIX = -B here
	real*8 A,B,C,L,R,S,P,D
      common/stixdata/ A,B,C,L,R,S,P,D



	character*100 LGR_testfile
      integer*4 LGR_testmode
      real*8 LGR_WT(NVPMAX,NMMAX,8)
	common/LGRtdata/ LGR_testfile, LGR_testmode,LGR_WT
	end module mod_WavesWork

	subroutine LGR_SETUP(psdstr,n2str,mstr,m0,m1)
	use mod_WavesWork
	implicit none
	character*(*) mstr,n2str,psdstr
	integer*4 m0,m1
	mresmdl=mstr(1:3)
	n2mdl=n2str(1:3)
	psdmdl=psdstr(1:6)  
	mstart=m0
	mend=m1
	end
