	subroutine griddata2(x,y,f,m,xnew,ynew,fnew,mnew)
c     this subroutine is to interpolate fnew(xnew,ynew) from f(x,y)      
c     using triangulation interpolation from NAG library
c     (subroutines E01SAF, E01SBF)
c     written for double precision
c     m: the size of x,y,f array
c     mnew: the size of xnew,ynew,fnew array
c     Lunjin Chen, 2009/12/25

	implicit none
	real*8 x(m),y(m),f(m)
	real*8 xnew(mnew),ynew(mnew),fnew(mnew)
	integer*4 m,mnew  

      INTEGER          NIN, NOUT
      PARAMETER        (NIN=5,NOUT=6)
	integer*4 mmax,nmax
      PARAMETER        (MMAX=100,NMAX=25)
*     .. Local Scalars ..
      INTEGER          I, J,IFAIL 
*     .. Local Arrays ..
      DOUBLE PRECISION  GRADS(2,M)
      INTEGER          TRIANG(7*M)
*     .. External Subroutines ..
      EXTERNAL         E01SAF, E01SBF
*     .. Intrinsic Functions ..
      INTRINSIC        DBLE

	integer*4 sz1,sz2


*        Generate the triangulation and gradients.
         IFAIL = 1
*
         CALL E01SAF(M,X,Y,F,TRIANG,GRADS,IFAIL)
*
	   IFAIL=0
         IF (IFAIL.EQ.0 .OR. IFAIL.EQ.3) THEN
               DO 100 I = 1,mnew
                     IFAIL = 1
                     CALL E01SBF(M,X,Y,F,TRIANG,GRADS,
     1			xnew(i),ynew(i),fnew(i),IFAIL)
c	  		   write(*,*) i,IFAIL,fnew(i)
  100          CONTINUE
				
         ELSE
               WRITE (NOUT,99997) IFAIL
         END IF

99997 FORMAT (1X,' ** E01SAF returned with IFAIL = ',I5)
      END
