	subroutine ms_instab
c	this subroutine is to investigate the magnetosonic instabitlity	
c	by calculate the local growth rate from raw MPA data
c	- call read_mpabin first
c     - evaluate dfdvp dfdvz from pitch angle and energy distribution of protons
c     - set up dip/T96 magnetic field, solar wind parameter required
c     - scan each harmonic wave frequencies from 3 to 45 Omega_H
c     Lunjin Chen, 2010/1/5

	use mod_mpadata
      use mod_WavesWork, only : LGR_WT, VPARR, DVPARR, NVPMAX, 
     1      output_gr
	implicit none

	integer*4 iAZ,iPO,iEN,iREC,iPA,iGA,iPA90,iEN2
	real*4 PARMOD(10)
	real*4  XGSM,YGSM,ZGSM,BXGSM,BYGSM,BZGSM,PS
	real*4 Pdyn_nPa,Dst_nT,BYIMF_nT,BZIMF_nT
	integer*4 IOPT
	external GEOGSM_08

      integer*4 nvpnew
	integer*4 nVVnew,nPAnew
	integer*4 nVVMAX0,nPAMAX0
	parameter(nVVMAX0=100,nPAMAX0=100)
	real*8 VVARRnew(nVVMAX0),PAARRnew(nPAMAX0)
	real*8 LNPSD2dnew(nVVMAX0,nPAMAX0)  

	real*4 BXGSMi,BYGSMi,BZGSMi,BXGSMe,BYGSMe,BZGSMe,BBi,BBe
	real*4 BXGSMd,BYGSMd,BZGSMd,BBd
	real*8 BYIMF,BZIMF,NSW,VSW,Dst
	real*8 VGSEX,VGSEY,VGSEZ
	real*4 R,THETAR,PHIR,BR,BTHETA,BPHI,BX,BY,BZ
	integer*4 iirec1,iirec2

	real*8 b2fch,den2fpe
	integer*4 ixh
	real*8 MASKnew(3,10)
	logical file_exist
	integer*4 nflag
	character*3 psdsclnew

      integer*4 flagREC,startREC,endREC
      integer*4 flagXH,startXH,endXH
      character*1 cmd
      integer*4 icall
      data icall/0/
      save icall,cmd,startREC,endREC,startXH,endXH

      character*200 testfile

      real*8 vzmin,vzmax,vpmin,vpmax
      integer*4 iq,imas

      integer*4 vploc(nENMAX),thisloc
      real*8 vpdiff(NVPMAX)
      integer*4 minloc

      real*8 Contrib(NVPMAX)      
c      real*8 Contribsum(nENMAX)
      real*8, dimension(nRECMAX,50,nENMAX) :: Contribsum
      integer*4 LocMAXContrib(nRECMAX,50)
      character*10 str10
      


      startREC=1
      endREC=nREC
      startXH=3
      endXH=45
      Contribsum=0.0d0
      LocMAXContrib=0

      if (icall.eq.0) then
c       setup B model and PSD interpolation
                write(*,*) 'Enter bmod: T96 or dip' 
                read(*,'(a3)') bmod
                write(*,'(a3)') bmod

                write(*,*) 'Enter psdscl: log or lin' 
                read(*,'(a3)') psdscl
                write(*,'(a3)') psdscl

                write(*,*) 'Enter Erngmin (ev):'
                read(*,*) Erngmin
                write(*,*) Erngmin

                write(*,*) '(r)un or (t)est:'                
                read(*,'(a1)') cmd
                write(*,'(a1)') cmd

c     test mode      
            if (cmd.eq.'t') then
              write(*,*) 'Enter REC range: startREC, endREC'
              read(*,*) flagREC,startREC, endREC
              write(*,*) flagREC,startREC, endREC
              if(flagREC.eq.0) then
                      startREC=1
                      endREC=nREC
              endif
              write(*,*) 'Enter XH rng: flagXH,startXH, endXH'
              read(*,*) flagXH,startXH, endXH
              write(*,*) flagXH,startXH, endXH
              if(flagXH.eq.0) then
                      startXH=3
                      endXH=45
              endif
            endif
      endif
      icall=icall+1
      write(str10,'(i2.2,"kev")')nint(Erngmin*1e-3)

      mspath=trim(mpapath2)//trim(mpafile0)//'/'  
      call system('mkdir -p '//trim(mspath))
	msfile=trim(mspath)//
     1      trim(mpafile0)//'_ms_'//bmod//'_'//psdscl//
     2      '_'//trim(str10)

c     1      trim(mpafile0)//'_ms_'//bmod//'_'//psdscl//'_EA'

      write(*,*) mspath
      write(*,*) msfile




	flag_data=0
	if(.not.file_exist(mpafile)) go to 999

c	smart searching
	iirec1=-1
	iirec2=-1
c	safe searching	
	iirec1=1
	iirec2=1

	EA=-1.0d31
	kis=-1.0e31
	gamma1s=-1.0e31
	nflag=0

c    find the index where ecp>1 keV 
c     iENh index for energy upper limit
c     iENl index for energy lower limit
c     Note: iENl > iENh
      do iENh=1,nEN,1
            if(ecp(iENh).ge.Erngmin) go to 31
      enddo
  31  continue    
      do iENl=nEN,1,-1
            if(ecp(iENl).ge.Erngmin) go to 32
      enddo
  32  continue    
      if(iENl.le.iENh) go to 999
      nENv=iENl-iENh+1


      do iREC=startREC,endREC

      IHOUR=floor(uthours(iREC))
      IMIN=floor((uthours(iREC)-IHOUR)*60)
      ISEC=floor((uthours(iREC)-IHOUR-IMIN/60.0)*3600)

c	load omni data
	call get_sw_data(iyear,doy,ihour,imin,BYIMF,BZIMF,NSW,VSW,Dst,
     1	    VGSEX,VGSEY,VGSEZ,iirec1,iirec2)
c	Dynamic Pressure in nPa
	  	Pdyn_nPa=(NSW*1d6)*hmas*(VSW*1d3)**2*1d9

c	checking sw_data
c	Pdyn 0.5 ~ 10 nPa
c	Dst -100 ~ +20 nT
c	ByIMF, BzIMF -10 ~ +10 nT
c	NSW #/cm**3
c	VSW km/s

	if (dens_lop(iREC).lt.-1e30.or.dens_lop(iREC).lt.1e-1) then
		flag_data(iREC)=flag_data(iREC)+1
	endif
	if(bmod.eq.'T96') then
		if(BYIMF.lt.-1e30
     1		.or.BZIMF.lt.-1e30
     2		.or.NSW.lt.-1e30
     3		.or.VSW.lt.-1e30
     4		.or.Dst.lt.-1e30) then
			flag_data(iREC)=flag_data(iREC)+2
		endif
	elseif(bmod.eq.'dip') then
	else  
	endif


	if(flag_data(iREC).eq.0) then
		nflag=nflag+1

c  *********************************************************************  
c  ***********************   magnetic field model  *********************  
c  *********************************************************************  

	  	VGSEX=VSW
		VGSEY=0.0d0
		VGSEZ=0.0d0

     		CALL RECALC (IYEAR,DOY,IHOUR,IMIN,ISEC)
c		CALL RECALC_08(IYEAR,DOY,IHOUR,IMIN,ISEC,VGSEX,VGSEY,VGSEZ)

c   TRANSFORM GEOGRAPHICAL GEOCENTRIC COORDS INTO SOLAR MAGNETOSPHERIC ONES:
      	CALL GEOGSM (XGEO(iREC),YGEO(iREC),ZGEO(iREC),
     1		    XGSM,YGSM,ZGSM,1)


	if(bmod.eq.'T96') then
c	using IGRF+T96  
		CALL IGRF_GSM (XGSM,YGSM,ZGSM,BXGSMi,BYGSMi,BZGSMi)
c		CALL IGRF_GSW_08 (XGSM,YGSM,ZGSM,BXGSMi,BYGSMi,BZGSMi)
c	external magnetic field model  
      	PARMOD(1)=Pdyn_nPa
      	PARMOD(2)=Dst
      	PARMOD(3)=BYIMF
      	PARMOD(4)=BZIMF
		PS=0
		CALL T96_01 (0,PARMOD,PS,XGSM,YGSM,ZGSM,BXGSMe,BYGSMe,BZGSMe)
	  	BXGSM=BXGSMi+BXGSMe
	  	BYGSM=BYGSMi+BYGSMe
	  	BZGSM=BZGSMi+BZGSMe
		BBi=sqrt(BXGSMi**2+BYGSMi**2+BZGSMi**2)
		BBe=sqrt(BXGSMe**2+BYGSMe**2+BZGSMe**2)
	elseif(bmod.eq.'dip') then
c	using dipole field approximation
	  	CALL DIP (XGSM,YGSM,ZGSM,BXGSMd,BYGSMd,BZGSMd)
	  	BXGSM=BXGSMd
	  	BYGSM=BYGSMd
	  	BZGSM=BZGSMd
		BBd=sqrt(BXGSMd**2+BYGSMd**2+BZGSMd**2)
	else
	endif	

	BB(iREC)=sqrt(BXGSM**2+BYGSM**2+BZGSM**2)*1d-9
	EA(iREC)=0.5d0*BB(iREC)**2/mu0/(dens_lop(iREC)*1d6)/ev



c ***********************************************
c ******* instability analysis ******************
c ***********************************************
c	setup phase space density
	VVARRnew(1:nENv)=sqrt(ecp(iENl:iENh:-1)*ev*2/hmas)
	PAARRnew(1:nPA)=PAgrid(1:nPA)
	psdsclnew=psdscl
	if(psdsclnew.eq.'lin') then
		LNPSD2dnew(1:nENv,1:nPA)=psd3d_pa(iREC,iENl:iENh:-1,1:nPA)
	elseif(psdsclnew.eq.'log') then
		LNPSD2dnew(1:nENv,1:nPA)=log(psd3d_pa(iREC,iENl:iENh:-1,1:nPA))
	else
		stop
	endif

      if(nflag.eq.1) then
c      if(iREC.eq.startREC) then

c     setup information for species             
	      nVVnew=nENv
	      nPAnew=nPA
	      MASKnew=-1d0
	      MASKnew(1:3,4)=(/ 1d0, VVARRnew(1), VVARRnew(nENv) /)
            nvpnew=5000
            call PIG_INIT
            vzmin=-VVARRnew(nENv)*1.0d0
            vzmax=VVARRnew(nENv)*1.0d0
            vpmin=VVARRnew(1)*1.0d0
            vpmax=VVARRnew(nENv)*1.0d0
            iq=1
            imas=1
            call PIG_SETUP(iq,imas,vzmin,vzmax,
     1            vpmin,vpmax,'lin',nvpnew)

c     find the index of ecp in VPARR    
            do iEN2=1,nENv
                  vpdiff(1:nvpnew)=dabs(VVARRnew(iEN2)-VPARR(1:nvpnew))
                  thisloc=minloc(vpdiff(1:nvpnew),DIM=1)
                  vploc(iEN2)=thisloc
            enddo
      endif


c     update phase space density      
	call dfvvpa_data_setup(nVVnew,nPAnew,
     1            VVARRnew,PAARRnew,LNPSD2dnew,MASKnew,psdsclnew)

      do ixh=startXH, endXH

c	setup waves of interest
		call LGR_SETUP('dfdata','n2m','spe',ixh,ixh)
            if(cmd.eq.'t') then
                  write(testfile,'("_",i3.3,"_",i2.2)')iREC,ixh
                  call PIG_TEST_ON(trim(msfile)//trim(testfile))
            endif
		ioneta1=1.0d0
		ioneta2=0.0d0
		psid=89.5d0
		xH=ixH*1.0d0
		xHs(ixh)=xH
		OmegaH=b2fch(BB(iREC)*1d0)*2*pi
		wpe=den2fpe(dens_lop(iREC)*1.0d6)*2*pi
      	call LocalGrowthRate(ioneta1,ioneta2,
     1		OmegaH,wpe,xH,psid,n2,ki,gamma1)
		kis(iREC,ixh)=ki
		gamma1s(iREC,ixh)=gamma1
c                 
c     Contrib for ki = Wp dfdvp dvp            
c     LocMAXContrib is the vp index of maximum weighting on ki
c     output_gr(10) = OmegaH/vg
            Contrib=LGR_WT(1:nvpnew,1,2)*LGR_WT(1:nvpnew,1,8)
     1         *DVPARR(1:nvpnew)*output_gr(10)
            LocMAXContrib(iREC,ixh)=
     1            maxloc(LGR_WT(1:nvpnew,1,8),dim=1)       

c     ki(t,omega,iEN) with dimension nREC, nXH, nENv-1    
c     ki(t,omega)=sum(ki(t,omega,iEN)) over iEN
            do iEN2=1,nENv-1
                  Contribsum(iREC,ixh,iEN2)=
     1       sum(Contrib(vploc(iEN2):vploc(iEN2+1)-1))
            enddo

	enddo ! ixh



c      endif ! EA

	endif ! flag_data

	enddo ! iREC
	
c
c   *** output analysis result of magnetosonic wave instability ***
      if(cmd.eq.'r') then
      call openbin(fidbin,trim(msfile))
	write(fidbin) nREC,nEN  
	write(fidbin) ecp(1:nEN),uthours(1:nREC),glt(1:nREC),EA(1:nREC)
	write(fidbin) psd2d_pa90(1:nREC,1:nEN)
	write(fidbin) kis(1:nREC,1:50)
      write(fidbin) flag_data(1:nREC)
      write(fidbin) nENv,iENl,iENh,nvpnew
      do iEN2=1, nENv-1
      do ixh=1, 50
            write(fidbin) Contribsum(1:nREC,ixh,iEN2)
      enddo
      enddo
      do ixh=1, 50
            write(fidbin) LocMAXContrib(1:nREC,ixh)
      enddo
      write(fidbin) VPARR(1:nvpnew)
	close(fidbin)
      endif

 999	continue
        
	end
