function plot_psd3d_pa(psd3dfile)
if(nargin<1)
    psd3dfile='./mpadata/a1_h0_mpa_20050831_v02.cdf.bin2'
    psd3dfile='./mpadata/a1_h0_mpa_20010422_v02.cdf.bin2'
end
if(~exist(psd3dfile,'file')),display('*** not exist ***');return;,end;
load physicsconstant.mat

ecpind=1:15;

fid=fopen(psd3dfile);
nREC=fread(fid,1,'int32');
nEN=fread(fid,1,'int32');
nPO=fread(fid,1,'int32');
nAZ=fread(fid,1,'int32');
nPA=fread(fid,1,'int32');
nGA=fread(fid,1,'int32');
psd3d_pa=fread(fid,nREC*nEN*nPA,'double');
psd3d_pa=reshape(psd3d_pa,[nREC,nEN,nPA]);
uthours=fread(fid,nREC,'float');
glt=fread(fid,nREC,'float');
ecp=fread(fid,nEN,'float');
PAgrid=fread(fid,nPA,'double');
[PA_g2d,ecp_g2d]=meshgrid(PAgrid,ecp(ecpind));
vv_g2d=sqrt(2*ecp_g2d*ev/hmas);
vp=vv_g2d.*sin(PA_g2d);
vz=vv_g2d.*cos(PA_g2d);
PAgrid=PAgrid*180/pi;
fclose(fid);

for iREC=1:1

psd2d_pa=squeeze(psd3d_pa(iREC,:,:));
iPA90=(nPA+1)/2;
timestr=datestr(uthours(iREC)/24,'HH:MM');
glttimestr=datestr(glt(iREC(1)),'HH:MM');

figure(90)
%set(gcf,'visible','off')
subplot(121)
clcarr=flipud(jet(length(ecpind)));
for iEN=ecpind
     if iEN==1
        semilogy(PAgrid',psd2d_pa(iEN,:),'color',clcarr(iEN,:))
        hold on
     else
        plot(PAgrid',psd2d_pa(iEN,:),'color',clcarr(iEN,:))
     end
 end
 psdrng=[1e-16,1e-11];
 plot([90 90],psdrng,':k')
 hold off
 ylim(psdrng)
 xlim([0 180])
 xlabel('PA, deg')
 ylabel('PSD, s3m-6 ')
 %title(datafile,'interpreter','none')

subplot(122)
loglog(ecp',psd2d_pa(:,iPA90),'k')
hold on
for iEN=ecpind
	scatter(ecp(iEN)',psd2d_pa(iEN,iPA90),'*','cdata',clcarr(iEN,:))
end
	hold off
  	%title(['ut',num2str(uthours(iREC))])
  	title([timestr,'UT, ',glttimestr,'LT'],'fontsize',15)
  	ylim(psdrng)
  	xlim([1e3,5e4])
  	xlabel('E, eV')
%  	saveas(90,jpgfile)

figure(91)
pcolor(vz,vp,log10(psd2d_pa(ecpind,:)))
caxis(log10(psdrng))
colormap(jet(255))
end % iREC
return
