	module mod_mpadata
	implicit none
	real*8 pi,rad,mu0,ev,emas,hmas
	parameter(pi=3.14159265,rad=pi/180)
	parameter(mu0=4.0*pi*1e-7,ev=1.60210e-19)
      parameter (emas=9.10908d-31,hmas=1.67252d-27)
	real*8 RE
	parameter(RE=6380d3)
	real*8 accumtime,count_cr  
	parameter(accumtime=9e-3,count_cr=-1e30)
	real*8 psdmin
	parameter(psdmin=1e-17)
	real*8 fillvalue
	parameter(fillvalue=-1d31)

         

	character*3 bmod,psdscl
c	bmod: T96 dip selecting b model
c	psdscl: lin log selecting intepolation on psd
c	parameter(bmod='dip',psdscl='lin')

	integer*4 fidmpafile,fidmpafile2,fidbin
	parameter(fidmpafile=15,fidmpafile2=16)
	parameter(fidbin=14)
	logical flag_mpa_update  
	parameter(flag_mpa_update=.false.)
	character*200 mpafile,mpafile2,binfile,msfile
     1 ,mpapath,mpapath2,mpalist,mspath
     2 ,mpafile0
	common/mpa_info/mpapath,mpapath2,mpalist,mspath,
     1            mpafile,mpafile2,binfile,msfile,mpafile0,
     2            bmod,psdscl

	integer*4 nRECMAX,nENMAX,nPOMAX,nAZMAX
	integer*4 nPAMAX,nGAMAX
	parameter(nRECMAX=1000,nENMAX=40)
	parameter(nPOMAX=6,nAZMAX=24)
	parameter(nPAMAX=37,nGAMAX=12)

	integer*4 nREC,nEN,nPO,nAZ
	integer*4 nPA,nGA
	integer*4 flag_data(nRECMAX)
	common/mpa_dim/ nREC,nEN,nPO,nAZ,nPA,nGA,flag_data


	integer*4 IYEAR,IMONTH,IDAY,DOY
	integer*4 IHOUR,IMIN,ISEC
	common/mpa_time/IYEAR,IMONTH,IDAY,DOY,
     1	 IHOUR,IMIN,ISEC

	real*8 PAgrid(nPAMAX),GAgrid(nGAMAX)
	real*8, dimension(nRECMAX,nENMAX) :: psd2d_pa90
	real*8, dimension(nRECMAX,nENMAX,nPAMAX) :: psd3d_pa
	common /mpa_data2/ PAgrid,GAgrid,psd2d_pa90,psd3d_pa


	real*4, dimension(nRECMAX,nENMAX,nPOMAX,nAZMAX) :: Pcounts,  
     1	pa4d,psd4d
	real*4, dimension(nPOMAX) :: etimesg
	real*4, dimension(nENMAX) :: effecp,ecp
	real*4, dimension(nRECMAX) :: theta_B, phi_B, Ae
	real*4, dimension(nRECMAX) :: sthB, cthB, sphB, cphB
	real*4, dimension(nRECMAX) :: xB, yB, zB
	real*4, dimension(nPOMAX) :: theta_LK, sthLK, cthLK
	real*4, dimension(nRECMAX,nENMAX,nAZMAX) :: phi_LK, sphLK,cphLK
	real*4, dimension(nRECMAX) :: uthours, dens_e, dens_hip, 
     1	  dens_lop, Poten, xgeo, ygeo, zgeo
     	real*4, dimension(nRECMAX,3,3) :: RotMat
	real*4, dimension(nRECMAX) :: longgeo,glt
	integer*4, dimension(nRECMAX) :: flags
	common /mpa_data1/ Pcounts,pa4d,psd4d,
     1	etimesg,effecp,ecp,theta_B, phi_B, Ae,
     2	sthB, cthB, sphB, cphB,
     3	xB, yB, zB,
     4	theta_LK, sthLK, cthLK,
     5	phi_LK, sphLK,cphLK,
     6	uthours, dens_e, dens_hip, 
     7	dens_lop, Poten, xgeo, ygeo, zgeo,
     8	longgeo,glt,
     9	RotMat, flags


	integer*4 nENv
c	parameter(nENv=15) ! lower cutoff E= 1.068 keV
c	parameter(nENv=16) ! lower cutoff E= 0.817 keV
	integer*4 iENh,iENl
	
     	integer*4 nHMAX
	parameter(nHMAX=50)
      real*8, dimension(nRECMAX,nHMAX) :: kis,gamma1s
	real*8, dimension(nHMAX) :: xHs  
	real*8 ioneta1,ioneta2,OmegaH,wpe,xH,psid,n2,ki,gamma1
	real*8, dimension(nRECMAX) :: BB, EA
      real*8 erngmin
	common/mpa_ms/ xHs,kis,gamma1s,BB,EA,
     1 ioneta1,ioneta2,OmegaH,wpe,xH,psid,n2,ki,gamma1,erngmin

	end module
	





	subroutine read_mpabin(thismpafile0)
c     - read MPA data
c     - convert count rate to PSD
c     - calculate pitch angle and gyro phase
c     - construct 4-d proton PSD as a function of pitch angle (PA), 
c           gyro angle (GA), energy (E) and time (T)
c     - average PSD over gyro phase to obtain 3-d proton PSD (PA,E,T)
c     Lunjin Chen, 2009/12/26

	use mod_mpadata
	implicit none
	character*(*) thismpafile0
	integer*4 tmpflag
	integer*4 i,j
	integer*4 iAZ,iPO,iEN,iREC,iPA,iGA,iPA90

	real*8 xLK,yLK,zLK,LKb
	real*8, dimension(nPAMAX,nGAMAX) :: xpB,ypB,zpB,xp,yp,zp,phip,thep
	real*8, dimension(3,3) :: thisRM

	real*8, dimension(nPOMAX*nAZMAX) :: phis_old,thes_old,psd_old
	real*8, dimension(nPAMAX*nGAMAX) :: phis_new,thes_new,psd_new
	integer*4 numold,numnew

	real*8, dimension(nPAMAX,nGAMAX) :: psd2d_new
	real*8, dimension(nPAMAX) :: psdpa

	logical file_exist  
	integer*4 ind1,ind2,ind3

	external griddata2



c	check existence of mpa file
      mpafile0=trim(thismpafile0)
	mpafile=trim(mpapath)//trim(mpafile0)
	mpafile2=trim(mpapath)//trim(mpafile0)//'2'
	if(.not.file_exist(mpafile)) go to 999



c  	*********************************************************
c  	************ reading mpa data block *********************
c  	*********************************************************
	open(unit=fidmpafile,file=trim(mpafile),form='binary')

c	begin reading mpa data
c	unformatted output from IDL
c	tmpflag: 4_byte_recflag
c	tmpflag rec1 tmpflag rec2 tmpflag rec3 .....
	read(fidmpafile) tmpflag
	read(fidmpafile) nREC,nEN,nPO,nAZ
	read(fidmpafile) tmpflag
	write(*,*) nREC,nEN,nPO,nAZ

	read(fidmpafile) tmpflag
c	get 4-D Pcounts
c	maximum number of dimension equal 3
	do iAZ=1,nAZ
	do iPO=1,nPO
c		read(fidmpafile) Pcounts(1:nREC,1:nEN,1:nPO,iAZ)
		read(fidmpafile) Pcounts(1:nREC,1:nEN,iPO,iAZ)
	enddo
	enddo

	read(fidmpafile) etimesg(1:nPO)
	read(fidmpafile) effecp(1:nEN)
	read(fidmpafile) ecp(1:nEN)
	read(fidmpafile) theta_B(1:nREC)
	read(fidmpafile) phi_B(1:nREC)
	read(fidmpafile) Ae(1:nREC)
	read(fidmpafile) theta_LK(1:nPO)
	read(fidmpafile) phi_LK(1:nREC,1:nEN,1:nAZ)
	read(fidmpafile) xgeo(1:nREC)
	read(fidmpafile) ygeo(1:nREC)
	read(fidmpafile) zgeo(1:nREC)
	read(fidmpafile) uthours(1:nREC)
	read(fidmpafile) dens_hip(1:nREC)
	read(fidmpafile) dens_lop(1:nREC)
	read(fidmpafile) dens_e(1:nREC)
	read(fidmpafile) flags(1:nREC)
	read(fidmpafile) Poten(1:nREC)  
c	write(*,*) etimesg
c	write(*,*) Poten(1:nREC)
	read(fidmpafile) tmpflag
c	finish reading	
	close(fidmpafile)  
c  	*********************************************************
c  	********** end of reading *******************************
c  	*********************************************************




c  	*********************************************************
c  	******** converting mpa data ****************************
c  	*********************************************************

c	get the date from mpa data filename	
	ind3=index(mpafile0,'_v02.cdf.bin')
	ind2=ind3-1
	ind1=ind2-8+1
	read(mpafile0(ind1:ind2),'(I4.4,I2.2,I2.2)') IYEAR,IMONTH,IDAY
c	calculate day of year
	call cvt_date_f(IYEAR,IMONTH,IDAY,DOY)

c	GEO coordinate km -> RE
	xgeo=xgeo*1e3/RE
	ygeo=ygeo*1e3/RE
	zgeo=zgeo*1e3/RE

c	longgeo in degree
c	glt in hour
	longgeo=atan2(ygeo,xgeo)/rad
	glt=mod(uthours+longgeo/15,24.0d0)


c the direction of B field in spin-axised coor
c B direction contains invalid number (-1e31), should set to NaN
c theta_B, phi_B : degree -> rad
	theta_B=theta_B*rad
	phi_B=phi_B*rad
	sthB=sin(theta_B)
	cthB=cos(theta_B)
	sphB=sin(phi_B)
	cphB=cos(phi_B)

c xB,yB,zB of B in spin-axised
c x pointing geographic north
c z pointing toward the Earth
c y make right-handed coordinate
	xB=sthB*cphB
	yB=sthB*sphB
	zB=cthB


c 	theta_LK [nPO] in rad
c	phi_LK [nREC, nEN, nAZ] in rad
	sthLK=sin(theta_LK)
	cthLK=cos(theta_LK)
	sphLK=sin(phi_LK)
	cphLK=cos(phi_LK)






	nPA=nPAMAX
	nGA=nGAMAX
	PAgrid=(/ ( (iPA-1)*1.0d0/(nPA-1)*180d0,iPA=1,nPA ) /)
	GAgrid=(/ ( (iGA-1)*360d0/nGA,iGA=1,nGA ) /)
	PAgrid=PAgrid*rad  
	GAgrid=GAgrid*rad  




c **************************************************
c * * calculating pa4d, psd4d, psd3d_pa starts  * *
c * * do not load pa4d psd4d
c **************************************************
	if(file_exist(mpafile2).and.(.not.flag_mpa_update)) then
		call openbin(fidbin,trim(mpafile2))
		read(fidbin) nREC,nEN,nPO,nAZ,nPA,nGA
c		read(fidbin) (psd3d_pa(1:nREC,1:nEN,iPA),iPA=1,nPA)
		read(fidbin)
     1  (((psd3d_pa(iREC,iEN,iPA),iREC=1,nREC),iEN=1,nEN),iPA=1,nPA)
		close(fidbin)
c * * remove spikes along vp at PA=90
c            iPA90=(1+nPA)/2
c            do iREC=1,nREC
c            psd2d_pa90(1:nEN)=psd3d_pa(iREC,1:nEN,iPA90)
c            enddo
c            dpsd=ecp(psd2d_pa90(2:nEN)-psd2d_pa90(1:nEN-1)

	else

c	pa4d pitch angle [nREC,nEN,nPO,nAZ]
c	pa4d=-1d31
c	psd4d=-1d31


	do iREC=1,nREC
	do iEN=1,nEN
	do iPO=1,nPO
	do iAZ=1,nAZ
		xLK=sthLK(iPO)*cphLK(iREC,iEN,iAZ)
		yLK=sthLK(iPO)*sphLK(iREC,iEN,iAZ)
		zLK=cthLK(iPO)
		LKb=xB(iREC)*xLK+yB(iREC)*yLK+zB(iREC)*zLK
c		if(theta_B.gt.-1d30) then ! valid B direction
		pa4d(iREC,iEN,iPO,iAZ)=acos(-LKb)
        	psd4d(iREC,iEN,iPO,iAZ)=5.449e-25*1e12*
     1		Pcounts(iREC,iEN,iPO,iAZ)/ecp(iEN)**2
     2	      /(etimesg(iPO)*effecp(iEN)*accumtime)
c	  	endif
	enddo
	enddo
	enddo
	enddo

	where (psd4d.le.psdmin)
		psd4d=psdmin
	endwhere


c%%%%%% Rotation Matrix %%%%%
c  for spheric coordinate transformation
c  between (LK,AZ) and (PA,GA)
	RotMat(:,1,1)=cphB*cthB
	RotMat(:,1,2)=-sphB
	RotMat(:,1,3)=cphB*sthB
 
	RotMat(:,2,1)=sphB*cthB
	RotMat(:,2,2)=cphB
	RotMat(:,2,3)=sphB*sthB
    
	RotMat(:,3,1)=-sthB
	RotMat(:,3,2)=0
	RotMat(:,3,3)=cthB


c	xpB,ypB,zpB [nPA,nGA]
c	xp,yp,zp [nPA,nGA]
	do iGA=1,nGA
		xpB(:,iGA)=sin(PAgrid)*cos(GAgrid(iGA))
		ypB(:,iGA)=sin(PAgrid)*sin(GAgrid(iGA))
		zpB(:,iGA)=cos(PAgrid)
	enddo ! iGA


c	psdpa resultant pitch-angle distribution
c	psd2d_new resultant pa and ga distribution
	psdpa=0.0d0

	do iREC=1,nREC
  		thisRM=RotMat(iREC,:,:)
  		xp=xpB*thisRM(1,1)+ypB*thisRM(1,2)+zpB*thisRM(1,3)
  		yp=xpB*thisRM(2,1)+ypB*thisRM(2,2)+zpB*thisRM(2,3)
  		zp=xpB*thisRM(3,1)+ypB*thisRM(3,2)+zpB*thisRM(3,3)
c	xp,yp,zp -> phip,thep
  		phip=atan2(yp,xp)
	  	where (phip<0)
	  		phip=2*pi+phip
	  	endwhere
  		thep=acos(zp/sqrt(xp**2+yp**2+zp**2))

		do iEN=1,nEN
c		interpolation starts here
			numold=0
			do iPO=1,nPO
     			do iAZ=1,nAZ
c	select valid count meassurement which is above critial count rate
			if (Pcounts(iREC,iEN,iPO,iAZ) .gt. count_cr) then
				numold=numold+1
				phis_old(numold)=phi_LK(iREC,iEN,iAZ)
				thes_old(numold)=theta_LK(iPO)
				psd_old(numold)=psd4d(iREC,iEN,iPO,iAZ)
c				psd_old(numold)=log(psd4d(iREC,iEN,iPO,iAZ))
			endif
			enddo ! iAZ
			enddo ! iPO
c	set up new grid for phi and theta
c	then interpolate to obtain new psd_new
			numnew=nPA*nGA
			i=0
			do iPA=1,nPA
			do iGA=1,nGA
				i=i+1
				phis_new(i)=phip(iPA,iGA)
				thes_new(i)=thep(iPA,iGA)
			enddo ! iGA
			enddo ! iPA

			call griddata2(phis_old(1:numold),thes_old(1:numold),
     1		    psd_old(1:numold),numold,
     2		    phis_new(1:numnew),thes_new(1:numnew),
     3		    psd_new(1:numnew),numnew)
	  		where(psd_new.lt.psdmin)
	  			psd_new=psdmin
	  		endwhere

c	  		    psd_new(1:numnew)=exp(psd_new(1:numnew))
c			      

c	psd3d_pa is pitch angle and energy distribution
c	pa distribution is obtained by averaging psd over all ga
			i=0
			psdpa=0.0d0
			psd2d_new=0.0d0
			do iPA=1,nPA
			do iGA=1,nGA
				i=i+1
				psd2d_new(iPA,iGA)=psd_new(i)
				psdpa(iPA)=psdpa(iPA)+psd2d_new(iPA,iGA)
			enddo ! iGA
				psd3d_pa(iREC,iEN,iPA)=psdpa(iPA)/nGA
			enddo ! iPA
		enddo ! iEN
	enddo ! iREC

	call openbin(fidbin,trim(mpafile2))
	write(fidbin) nREC,nEN,nPO,nAZ,nPA,nGA
c	write(fidbin) (psd3d_pa(1:nREC,1:nEN,iPA),iPA=1,nPA)
	write(fidbin)
     1  (((psd3d_pa(iREC,iEN,iPA),iREC=1,nREC),iEN=1,nEN),iPA=1,nPA)
	write(fidbin) uthours(1:nREC),glt(1:nREC),ecp(1:nEN)
      write(fidbin) PAgrid(1:nPA) 
	close(fidbin)


	endif ! exist mpafile2
c **************************************************
c * * calculating pa4d, psd4d, psd3d_pa finished * *
c **************************************************


c ************************ 
	iPA90=(nPA+1)/2
	psd2d_pa90(1:nREC,1:nEN)=psd3d_pa(1:nREC,1:nEN,iPA90)
 999	continue
	end subroutine





