	module mod_sthem
      real*8 sthempara(10)
      common /sthemdata/ sthempara
	end module mod_sthem

      subroutine sthem(vz,vp,f,dfdvz,dfdvp)
c     Suprathermal electron model      
      use mod_PhyConst
      use mod_sthem
      implicit none

      real*8 crdenpp,crfid,crfidwidth
      parameter(crdenpp=50d6,crfid=15d0*3,crfidwidth=360d0)
      real*8 vz,vp,f,dfdvz,dfdvp
      real*8 para_pwl(10),para_bimax(10)
      real*8 rden,rL,rlat,rfid
      real*8 AN,npw,fidterm

      rden=sthempara(1)
      rL=sthempara(2)
      rlat=sthempara(3)
      rfid=sthempara(4)


c     condition of sthempara
      if (rden.le.crdenpp) then ! outside p.p.
      fidterm=(dcos(2.0d0*pi*(rfid-crfid)/crfidwidth)+1.0d0)*0.5d0
      AN=1.17d8*fidterm
      npw=3.51d0

      else ! inside p.p.
            AN=4.0d9
            npw=4.0d0
      endif
c      write(*,*) rfid,AN,npw
      

      sthempara(10)=AN
      sthempara(9)=npw

      para_pwl(1:4)=(/-1.0d0,memp,AN,npw/)
      call dfpwl(vz,vp,f,dfdvz,dfdvp,para_pwl)
      end



      subroutine sthem_data(vz,vp,f,dfdvz,dfdvp)
c     Suprathermal electron model      
      use mod_PhyConst
      use mod_sthem
      implicit none

      real*8 crdenpp,crLpp
      parameter(crdenpp=50d6)
      parameter(crLpp=3.55d0)
      real*8 vz,vp,f,dfdvz,dfdvp
      real*8 para_pwl(10),para_bimax(10)
      real*8 rden,rL,rlat,rfid,rMLT
      real*8 AN,npw,fidterm

      integer*4 icall
	save icall
	data icall/0/ 
      integer*4 iLx,jMLTx,iL,jMLT
      integer*4 NLsthe,NMLTsthe
      parameter(NLsthe=70,NMLTsthe=24)
      integer*4 iLpp
      real*8 Larr(NLsthe),MLTarr(NMLTsthe)
      real*8 ANarr(NLsthe,NMLTsthe),npwarr(NLsthe,NMLTsthe)
      common/sthem_comdata/ Larr,MLTarr,ANarr,npwarr,iLpp
      integer*4 matchind,matchindp
      
      integer*4 iw10,iw11

      if (icall.eq.0) then
              iw10=71
              iw11=72
c              call open_fmt(iw10,'sthem_stat.dat')
              open(unit=iw10,file='~/code/PIG/sthem_stat.dat',
     1	  form='formatted',status='unknown')
              open(unit=iw11,file='~/code/PIG/sthem_stat_mks.dat',
     1	  form='formatted',status='unknown')
              do 20 jMLT=1,NMLTsthe
              do 10 iL=1,NLsthe
                  read(iw10,*)
     1            MLTarr(jMLT),Larr(iL),ANarr(iL,jMLT),npwarr(iL,jMLT)
c     conversion from cms unit to mks unit     
                  ANarr(iL,jMLT)=
     1             ANarr(iL,jMLT)*10.0d0**(12.0-2.0*npwarr(iL,jMLT))
                 write(iw11,*)
     1            MLTarr(jMLT),Larr(iL),ANarr(iL,jMLT),npwarr(iL,jMLT)
 10           continue                  
 20           continue                  
            iLpp=matchind(Larr,1,NLsthe,3.55d0)
            close(iw10)
            close(iw11)
      endif
      rden=sthempara(1)
      rL=sthempara(2)
      rlat=sthempara(3)
      rfid=sthempara(4)
      rMLT=rfid/15.0d0


c     condition of sthempara
      if (rden.le.crdenpp) then ! outside p.p.
      iLx=matchind(Larr,iLpp+1,NLsthe-iLpp,rL)
      else ! inside p.p.
      iLx=matchind(Larr,1,iLpp,rL)
      endif
c      if (rL.ge.crLpp) then ! outside p.p.
c      iLx=matchind(Larr,iLpp+1,NLsthe-iLpp,rL)
c      else ! inside p.p.
c      iLx=matchind(Larr,1,iLpp,rL)
c      endif



      jMLTx=matchindp(MLTarr,1,NMLTsthe,24.0d0,rMLT)
      
      AN=ANarr(iLx,jMLTx)
      npw=npwarr(iLx,jMLTx)

      sthempara(10)=AN
      sthempara(9)=npw

      para_pwl(1:4)=(/-1.0d0,memp,AN,npw/)
      call dfpwl(vz,vp,f,dfdvz,dfdvp,para_pwl)


      icall=icall+1
      end













      subroutine sthem_data_L(vz,vp,f,dfdvz,dfdvp)
c     Suprathermal electron model      
      use mod_PhyConst
      use mod_sthem
      implicit none

      real*8 crdenpp,crLpp
      parameter(crdenpp=50d6)
      parameter(crLpp=3.55d0)
      real*8 vz,vp,f,dfdvz,dfdvp
      real*8 para_pwl(10),para_bimax(10)
      real*8 rden,rL,rlat,rfid,rMLT
      real*8 AN,npw,fidterm

      integer*4 icall
	save icall
	data icall/0/ 
      integer*4 iLx,jMLTx,iL,jMLT
      integer*4 NLsthe,NMLTsthe
      parameter(NLsthe=70,NMLTsthe=24)
      integer*4 iLpp
      real*8 Larr(NLsthe),MLTarr(NMLTsthe)
      real*8 ANarr(NLsthe,NMLTsthe),npwarr(NLsthe,NMLTsthe)
      common/sthem_comdata/ Larr,MLTarr,ANarr,npwarr,iLpp
      integer*4 matchind,matchindp
      
      integer*4 iw10,iw11

      if (icall.eq.0) then
              iw10=71
              iw11=72
              open(unit=iw10,file='~/code/PIG/sthem_stat.dat',
     1	  form='formatted',status='unknown')
              open(unit=iw11,file='~/code/PIG/sthem_stat_mks.dat',
     1	  form='formatted',status='unknown')
              do 20 jMLT=1,NMLTsthe
              do 10 iL=1,NLsthe
              read(iw10,*)
     1         MLTarr(jMLT),Larr(iL),ANarr(iL,jMLT),npwarr(iL,jMLT)
c     conversion from cms unit to mks unit     
      ANarr(iL,jMLT)=ANarr(iL,jMLT)*10.0d0**(12.0-2.0*npwarr(iL,jMLT))
              write(iw11,*)
     1         MLTarr(jMLT),Larr(iL),ANarr(iL,jMLT),npwarr(iL,jMLT)
 10           continue                  
 20           continue                  
            iLpp=matchind(Larr,1,NLsthe,crLpp)
             close(iw10)
             close(iw11)
      endif
      rden=sthempara(1)
      rL=sthempara(2)
      rlat=sthempara(3)
      rfid=sthempara(4)
      rMLT=rfid/15.0d0


c     condition of sthempara
c      if (rden.le.crdenpp) then ! outside p.p.
c      iLx=matchind(Larr,iLpp+1,NLsthe-iLpp,rL)
c      else ! inside p.p.
c      iLx=matchind(Larr,1,iLpp,rL)
c      endif
c      if (rL.ge.crLpp) then ! outside p.p.
c      iLx=matchind(Larr,iLpp+1,NLsthe-iLpp,rL)
c      else ! inside p.p.
c      iLx=matchind(Larr,1,iLpp,rL)
c      endif
      iLx=matchind(Larr,1,NLsthe,rL)



      jMLTx=matchindp(MLTarr,1,NMLTsthe,24.0d0,rMLT)
      
      AN=ANarr(iLx,jMLTx)
      npw=npwarr(iLx,jMLTx)

      sthempara(10)=AN
      sthempara(9)=npw

      para_pwl(1:4)=(/-1.0d0,memp,AN,npw/)
      call dfpwl(vz,vp,f,dfdvz,dfdvp,para_pwl)


      icall=icall+1
      end




