c     this source file is to read the solar wind data and Dst
c     solar wind data here include BYIMF, BZIMF,NSW,VSW,VGSEX,VGSEY,VGSEZ
c     Lunjin Chen, 2010/1/5

	module mod_sw_data
	implicit none
	real*8 fillvalue
	parameter(fillvalue=-1d31)
	integer*4 nrecmax
	parameter(nrecmax=50000)
	integer*4 nrec1
	integer*4, dimension(nrecmax) :: years1,doys1,hours1
	real*8, dimension(nrecmax) :: BYIMFs1,BZIMFs1,NSWs1,VSWs1,Dsts1	
	common/sw_data1/ nrec1,years1,doys1,hours1,
     1	BYIMFs1,BZIMFs1,NSWs1,VSWs1,Dsts1
	integer*4 nrec2
	integer*4, dimension(nrecmax) :: years2,doys2,hours2,mins2
	real*8, dimension(nrecmax) :: VGSEXs2,VGSEYs2,VGSEZs2
	common/sw_data2/ nrec2,years2,doys2,hours2,mins2,
     1	VGSEXs2,VGSEYs2,VGSEZs2
	end module mod_sw_data



	subroutine read_sw_data1(file1)
	use mod_sw_data  
	implicit none  

c	omni2_YYYYMMDD_YYYYMMDD.lst  hourly
	character*(*) file1
	integer*4 icall
	data icall/0/
	save icall
	integer*4 iyear,doy,ihour
	real*8 BY,BZ,NSW,VSW,Dst
	integer*4 fid
	fid=15
	if(icall.eq.0) nrec1=0
	open(unit=fid,file=trim(file1),form='formatted',status='unknown')
	do while (.true.)
	read(fid,*,END=999) iyear, doy, ihour, BY, BZ, NSW, VSW, Dst
c	invalid value=999.9
	if(BY.gt.900) BY=fillvalue
	if(BZ.gt.900) BZ=fillvalue
	if(NSW.gt.900) NSW=fillvalue
	if(VSW.gt.900) VSW=fillvalue
	if(Dst.gt.900) Dst=fillvalue

	nrec1=nrec1+1
	years1(nrec1)=iyear
	doys1(nrec1)=doy
	hours1(nrec1)=ihour
	BYIMFs1(nrec1)=BY
	BZIMFs1(nrec1)=BZ
	NSWs1(nrec1)=NSW
	VSWs1(nrec1)=VSW
	Dsts1(nrec1)=Dst
 	enddo
 999	continue	
	  
 	close(fid)
	icall=icall+1
	end

	subroutine read_sw_data2(file2)
	use mod_sw_data  
	implicit none  
c	omni_min_YYYYMMDD_YYYYMMDD.lst minutely 
	character*(*) file2
	integer*4 icall
	data icall/0/
	save icall
	integer*4 iyear,doy,ihour,imin
	real*8 vx,vy,vz
	integer*4 fid
	fid=15
	if(icall.eq.0) nrec2=0
	open(unit=fid,file=trim(file2),form='formatted',status='unknown')
	do while (.true.)
	read(fid,*,END=999) iyear, doy, ihour, imin, vx, vy,vz
c	invalid value=99999.9
	if(vx.gt.9e4) vx=fillvalue
	if(vy.gt.9e4) vy=fillvalue
	if(vz.gt.9e4) vz=fillvalue
	nrec2=nrec2+1
	years2(nrec2)=iyear
	doys2(nrec2)=doy
	hours2(nrec2)=ihour
	mins2(nrec2)=imin
	VGSEXs2(nrec2)=vx
	VGSEYs2(nrec2)=vy
	VGSEZs2(nrec2)=vz
	enddo
 999	continue	
 	close(fid)
	icall=icall+1
	end
	
	subroutine get_sw_data(iyear,doy,ihour,imin,BYIMF,BZIMF,NSW,VSW,Dst,
     1	    VGSEX,VGSEY,VGSEZ,iirec1,iirec2)
	use mod_sw_data
	implicit none
	integer*4 iirec1,iirec2
	integer*4 irec1,irec2
	save irec1,irec2
	integer*4 iyear,doy,ihour,imin
	real*8 BYIMF,BZIMF,NSW,VSW,Dst,VGSEX,VGSEY,VGSEZ
	integer*4 icall
	data icall/0/
	save icall
	if(iirec1.gt.0) irec1=iirec1
	if(iirec2.gt.0) irec2=iirec2
	do while (.true.)
	  if(iyear.eq.years1(irec1).and.doy.eq.doys1(irec1)
     1	.and.ihour.eq.hours1(irec1) ) then	
	  	BYIMF=BYIMFs1(irec1)
	  	BZIMF=BZIMFs1(irec1)
	  	NSW=NSWs1(irec1)
	  	VSW=VSWs1(irec1)
	  	Dst=Dsts1(irec1)
	  	go to 10
	  else
	  	irec1=irec1+1
		if(irec1.gt.nrec1) go to 10
	  endif
	enddo
 10	continue
	
	do while (.true.)
	  if(iyear.eq.years2(irec2).and.doy.eq.doys2(irec2)
     1	.and.ihour.eq.hours2(irec2).and.imin.eq.mins2(irec2))
     2		  then	
	  	VGSEX=VGSEXs2(irec2)
	  	VGSEY=VGSEYs2(irec2)
	  	VGSEZ=VGSEZs2(irec2)
	  	go to 20
	  else
	  	irec2=irec2+1
		if(irec2.gt.nrec2) go to 20
	  endif
	enddo
 20	continue
c 	write(*,*) 'irec1',irec1,'irec2',irec2
	icall=icall+1
	end
